Package: DropSeq.utilities
Type: Package
Title: Generic Drop-seq utilities
Version: 3.0.2
Date: 2024-07-15
Imports: data.table
Author: Alec Wysoker
Maintainer: McCarroll Lab <dropseq@gmail.com>
Description: Grab-bag of generic functions for handling strings, files, errors.
License: MIT + file LICENSE
RoxygenNote: 7.3.1
Encoding: UTF-8

Package: DropSeq.dropulation
Type: Package
Title: Tools for analyzing Dropulation data
Version: 3.0.2
Date: 2024-07-15
Imports: graphics, utils, stats, data.table,RColorBrewer,vegan, gridExtra,
    ggplot2,ggrepel,purrr,stringr,scales
Suggests: DropSeq.utilities
Remotes: github::broadinstitute/Drop-seq/src/R/packages/DropSeq.utilities
Author: Jim Nemesh
Maintainer: McCarroll Lab <dropseq@gmail.com>
Description: Dropulation and Dropulation census functions.
License: MIT + file LICENSE
RoxygenNote: 7.3.1
Encoding: UTF-8

# Drop-seq
Java and R tools for analyzing [Drop-seq](http://mccarrolllab.com/dropseq/) data

Drop-seq questions may be directed to [dropseq@gmail.com](mailto:dropseq@gmail.com).  
You may also use this address to be added to the Drop-seq Google group.

See [Releases](https://github.com/broadinstitute/Drop-seq/releases) to download binaries.

See [Drop-seq alignment cookbook](doc/Drop-seq_Alignment_Cookbook.pdf) for detailed usage of these tools.

See [Census-seq computational protocols](doc/Census-seq_Computational_Protcools.pdf) for detailed usage of Census-Seq tools.

See [Donor Assignment cookbook](doc/Donor_Assignment_Computational_Cookbook.pdf) for detailed usage of donor assignment and doublet detection tools.

# Building from source and installing

Download source:
```
git clone https://github.com/broadinstitute/Drop-seq.git 
cd Drop-seq
```

There are two options for building and installing Java code.  

- Build the executable jarfile, a single wrapper script from which all command-line programs can be invoked, installed in the cloned git sandbox.
- Build a zipfile containing the executable jarfile and wrapper scripts for all command-line programs.  The zipfile can be installed in an arbitrary location.

## Building the exectable jarfile and single wrapper script
`./gradlew installDist`

The wrapper script will be `dropseq/build/install/dropseq/bin/dropseq`.  `dropseq.bat` for Windows.
## Build zipfile containing executable jarfile and wrapper scripts
`./gradlew distZip`

### Installing
```
unzip -d <install-location> ./dropseq/build/distributions/dropseq-<version>.zip
```
Note that the name of the zipfile will be based on the tagged version and state of your git sandbox.

The files will be deployed into a subdirectory of `<install-location>` above, with name based on the name of the zipfile. 

## Building Drop-seq R libraries

You are encouraged to use the pre-built binaries in [Releases](https://github.com/broadinstitute/Drop-seq/releases), but 
if you want to build from (possibly unstable) sources, you can build from github source as follows:

For each library in src/R/packages, you can install using `devtools::install_github`, e.g.

```
devtools::install_github("broadinstitute/Drop-seq", subdir="/src/R/packages/DropSeq.utilities")  
```

Alternately, you can download sources and use `R CMD BUILD` and `R CMD INSTALL` as usual.

# Drop-seq
Java tools for analyzing [Drop-seq](http://mccarrolllab.com/dropseq/) data

Drop-seq questions may be directed to [dropseq@gmail.com](mailto:dropseq@gmail.com).  
You may also use this address to be added to the Drop-seq Google group.

See https://github.com/broadinstitute/Drop-seq/releases to download binaries.

See [Drop-seq alignment cookbook](doc/Drop-seq_Alignment_Cookbook.pdf) for detailed usage of these tools.

See [Census-seq computational protocols](doc/Census-seq_Computational_Protcools.pdf) for detailed usage of Census-Seq tools.

# Building Drop-seq R libraries
For each library in src/R/packages, you can install using `devtools::install_github`, e.g.

```
devtools::install_github("broadinstitute/Drop-seq", subdir="/src/R/packages/DropSeq.utilities")  
```

By default this will use the latest code in the master branch.  You may prefer to specify a tagged version with `ref=<tag>`. 

# DropSeq.utilities

<!-- badges: start -->
<!-- badges: end -->

DropSeq.utilities contains trivial functions to support other DropSeq R packages.

## Installation

The preferred installation method is to go to the latest release in
[Releases](https://github.com/broadinstitute/Drop-seq/releases) and follow the
instructions there.

It is not recommended to install the latest version of DropSeq.utilities from
[GitHub](https://github.com/), because it is not necessarily stable, but if you choose to do so:

``` r
# install.packages("devtools")
devtools::install_github("broadinstitute/Drop-seq", subdir="src/R/packages/DropSeq.utilities")
```

# DropSeq.dropulation

<!-- badges: start -->
<!-- badges: end -->

Dropulation and Dropulation census functions.

## Installation

The preferred installation method is to go to the latest release in 
[Releases](https://github.com/broadinstitute/Drop-seq/releases) and follow the
 instructions there.

It is not recommended to install the latest version of DropSeq.dropulation from 
[GitHub](https://github.com/), because it is not necessarily stable, but if you choose to do so:

``` r
# install.packages("devtools")
devtools::install_github("broadinstitute/Drop-seq", subdir="src/R/packages/DropSeq.dropulation")
```

Note that dependent package DropSeq.utilities is Suggests: rather than Imports: in order
to make it less likely that a user will install a possibly-unstable version of that package
rather than a released version.

# MIT License
#
# Copyright 2024 Broad Institute
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

#' Read a data.table using data.table fread()
#'
#' If inFile ends with .gz, it is gunzipped in a way that is robust to running out of disk space.
#' Environment variable DROPSEQ_TMPDIR should be set to a directory that has plenty of room and is writable.
#'
#' @param inFile path of file to be read
#' @param comment_regexp If defined, filter input through "egrep -v comment_regexp"
#' @param ... passed through to data.table::fread
#' @return a data.table
#' @import data.table
#' @export
fastRead<-function(inFile, comment_regexp=NA, ...) {
  if (!file.exists(inFile)) {
    stop(paste0(inFile, " does not exist"))
  }
  # fread writes process output to /dev/shm if it exists, which is OK so long as it is big enough.
  # If that fails, fall back to function that uses an explicit TMPDIR
  if (length(grep(".gz", inFile))==1) {
    unzip_command = paste("gunzip","-c",inFile,sep=" ")
    if (!is.na(comment_regexp)) {
      unzip_command = paste0(unzip_command, sprintf(" | egrep -v '%s'", comment_regexp))
    }
    # data.table 1.11.8 emits a warning if command string isn't passed via cmd=, but v 1.10.4 (current dotkit version)
    # doesn't recognized cmd=
    if (version_above("data.table", "1.11.8")) {
      return(tryCatch(data.table::fread(cmd=unzip_command,data.table=T, ...), error=function(e) fastReadBigGz(inFile, comment_regexp=comment_regexp, ...)))
    } else {
      return(tryCatch(data.table::fread(unzip_command,data.table=T, ...), error=function(e) fastReadBigGz(inFile, comment_regexp=comment_regexp, ...)))
    }

  } else {
    input = inFile
    if (!is.na(comment_regexp)) {
      input = sprintf("egrep -v '%s' %s", comment_regexp, inFile)
      a=data.table::fread(input, data.table=T, ...)
    } else {
      a=data.table::fread(input, data.table=T, ...)
    }
    return(a)
  }
}

# internal function
fastReadBigGz<-function(inFile, ...) {
  # Grid Engine overwrites TMPDIR, so support our own environment variable that won't get clobbered.
  tmpDir = Sys.getenv('DROPSEQ_TMPDIR')
  if (nchar(tmpDir) == 0) {
    tmpDir = Sys.getenv('TMPDIR')
  }
  if (nchar(tmpDir) == 0) {
    tmpDir = tempdir()
  }
  t=tempfile(tmpdir=tmpDir, fileext=".tsv")
  on.exit(unlink(t), add = TRUE)
  cmd=paste("gunzip -c", inFile, ">", t)
  retval = system(cmd,intern=F) != 0
  if (retval != 0) {
    stop(paste0(cmd, " failed with status ", retval))
  }
  return(fastRead(t, ...))
}

#' Read a tabular DGE, with gene rows and columns that typically are cell barcodes
#' @param file to be read, optionally gzipped
#' @param decreasing_order_by_size If true, columns are ordered in decreasing order by colsum
#' @return a data.frame with genes as rownames, no GENE column.
#' @export
#' @import data.table
read_dge_gz<-function(file, decreasing_order_by_size=TRUE) {
  dge = fastRead(file, comment_regexp = '^#')
  setkey(dge,GENE)
  gene_names = dge$GENE
  GENE <- NULL # Silence R CMD check warning https://www.r-bloggers.com/2019/08/no-visible-binding-for-global-variable/
  dge[, GENE:=NULL]
  rownames(dge) = gene_names

  if (decreasing_order_by_size) {
    # order cells by expression

    # I don't understand data.table, but this returns a data.table with one row rather than
    # a vector, so convert to list to avoid warnings
    colsums.full.data=unlist(dge[,lapply(.SD,sum,na.rm=TRUE),.SDcols=colnames(dge)])
    order.data=names(colsums.full.data)[order(colsums.full.data,decreasing=T)]
    full.data.cells=dge[,order.data,with=F]
  } else {
    full.data.cells = dge
  }
  full.data.cells = as.data.frame(full.data.cells)
  rownames(full.data.cells) = gene_names
  return(full.data.cells)
}

#' Creates a file connection with the given open mode.
#' @param file If ends with ".gz", a gzfile() is created; else a regular file() connection.
#' @param open mode in which file is opened.  Default: "rb"
#' @export
open_conn = function(file, open="") {
  if (strEndsWith(file, ".gz")) {
    # work around bug in gzfile:
    # https://stackoverflow.com/questions/45665496/how-would-one-readlines-from-a-gzip-file-in-r
    if (nchar(open) == 0) {
      open = "rb"
    }
    if (!strEndsWith(open, "b")) {
      open=paste0(open, "b")
    }
    return(gzcon(file(file, open=open)))
  } else {
    return(file(file, open=open))
  }
}

#' Write a tab-separated file with row and column labels, including a label for the rownames.
#' Additional args are passed to write.table
#' @param x the data frame to be written.
#' @param file where to write the data.  If suffix is ".gz", the file is gzipped.
#' @param rowname_label the column header for the rownames
#' @param quote passed to write.table
#' @param sep passed to write.table
#' @param col.names passed to write.table
#' @param ... passed to write.table
#' @export
write_table_with_label_for_rownames = function(x, file, rowname_label, quote=FALSE, sep="\t", col.names=TRUE, ...) {
  conn = open_conn(file=file, open="w")
  cat(paste0(rowname_label, '\t'), file=conn)
  utils::write.table(x, conn, col.names=col.names, row.names=TRUE, quote=quote, sep=sep, ...)
  close(conn)
}

#' Read a tab-separated file, drop the first column and use the values of the first column as rownames.
#' @param file If suffix is ".gz" it is assumed the file is gzipped.
#' @param ... passed to data.table::fread()
#' @export
#' @import data.table
read_table_with_label_for_rownames=function(file, ...) {
  ret = fastRead(file, ...)
  rowname_column = colnames(ret)[1]
  labels = ret[, get(rowname_column)]
  ret[, (rowname_column):=NULL]
  ret = as.data.frame(ret)
  rownames(ret) = labels
  return(ret)
}

#' Make sure the argument has a trailing slash.
#' @param directory path on which to operate
#' @return the input argument, with a slash appended if it doesn't already end with a slash
#' @export
ensure_trailing_slash=function(directory) {
  if (!strEndsWith(directory, "/")) {
    directory = paste0(directory, "/")
  }
  return(directory)
}

#' Check if a directory exists, and create it if not.  Errors if cannot be created or exists but is not a directory.
#' @param directory to be created
#' @param recursive if FALSE, the parent directory must exist.
#' @return the directory, always with a trailing slash.  Raises an error if cannot be created
#' @export
ensure_directory_exists = function(directory, recursive=TRUE) {
  directory = ensure_trailing_slash(directory)
  if (dir.exists(directory)) {
    return(directory);
  } else if (file.exists(directory)) {
    stop(paste0("Cannot create directory because there is an existing file with the same name: ", directory))
  } else if (!dir.create(directory, recursive=recursive)) {
    stop(paste0("Error creating directory: ", directory))
  } else {
    return(directory)
  }
}

#' Count the number of lines at the beginning of the file that start with @ or #
#' @param path text file to be read, possibly gzipped
#' @return the number of lines at the beginning of the file that start with '@' or '#'
#' @export
countHeaderLines = function(path) {
  conn = file(path, "r")
  on.exit(close(conn), add = TRUE)
  headerLength = 0
  while(strStartsWith(line<-(readLines(conn, n=1)[[1]]), '@') || strStartsWith(line, '#')) {
    headerLength = headerLength + 1
  }
  return(headerLength)
}

dge_header_attribute_name='Drop-seq.dge.header'

version_above <- function(pkg, than) {
  as.logical(utils::compareVersion(as.character(utils::packageVersion(pkg)), than))
}

#' Read a tabular DGE, that may have comment/header lines starting with '@' or '#'
#' @param path file to be read.  If has suffix ".gz" it is assumed to be gzipped.
#' @return a data.table with the tabular contents of the file, and header/comment lines attached
#'         as an attribute named 'Drop-seq.dge.header'
#' @import data.table
#' @export
read_dge_txt = function(path) {
  headerLength = countHeaderLines(path)
  dge = fastRead(path, skip=headerLength)
  if (headerLength > 0) {
    header = readLines(path, n=headerLength)
    attr(dge, dge_header_attribute_name) = header
  }
  return(dge)
}

#' Determine if a file is in matrix market file format.
#'
#' @param file The file to test
#'
#' @return true if the file is in matrix market format
#' @export
isMatrixMarket<-function(file) {
  conn=file(file, "r")
  line=readLines(con=conn, n=1, ok=FALSE)
  close(conn)
  return(strStartsWith(line, "%%MatrixMarket matrix coordinate"))
}

#' read the first fiew lines of a MatrixMarket file to get the header line.
#' @param file possibly gzipped
#' @return list(numRows, numCols, numPopulatedElements)
#' @export
getSparseMatrixDimensions=function(file) {
  conn=open_conn(file, "r")
  line = "%"
  while(strStartsWith(line, '%')) {
    line=readLines(con=conn, n=1, ok=FALSE)
  }
  fields = strsplit(line, "\t", fixed=TRUE)[[1]]
  return(list(numRows=as.numeric(fields[1]), numCols=as.numeric(fields[2]), numPopulatedElements=as.numeric(fields[3])))
}

#' Read enough of a file to get the number of rows and columns.
#' @param file possibly gzipped
#' @return list(numRows, numCols)
#' @export
getDenseDgeDimensions=function(file) {
  numCols = ncol(fastRead(file, nrows=1)) - 1
  # start at -1 because first line is a header
  numRows = -1
  conn = open_conn(file)
  while (TRUE) {
    l = readLines(conn, ok=TRUE, n=1)
    if (length(l) == 0) {
      break
    }
    if (!strStartsWith(l, "#")) {
      numRows = numRows + 1
    }
  }
  close(conn)
  return(list(numRows=numRows, numCols=numCols))
}

#' Determine size of sparse or dense DGE
#' @param file possibly gzipped
#' @return list(numRows, numCols, numPopulatedElements)
#' @export
getDgeDimensions<-function(file) {
  if (isMatrixMarket(file)) {
    return(getSparseMatrixDimensions(file))
  } else {
    ret = getDenseDgeDimensions(file)
    ret$numPopulatedElements = ret$numRows * as.numeric(ret$numCols)
    return(ret)
  }
}

#' Strings that appear in MatrixMarket files.
#' @export
MatrixMarketConstants = list(
  MM_COMMENT_LINE_START = "%",
  MM_STRUCTURED_COMMENT_LINE_START = "%%",
  MM_MATRIX_TYPE_GENERAL="general",
  MM_HEADER_LIST_SEPARATOR = "\t",
  real = "real",
  integer = "integer",
  real_element_format = "%d\t%d\t%.8g",
  integer_element_format = "%d\t%d\t%d"
)
MatrixMarketConstants$MM_HEADER_START = paste0(MatrixMarketConstants$MM_STRUCTURED_COMMENT_LINE_START, "MatrixMarket matrix coordinate")

# library (logger)
# library (ggplot2)

#' Estimate the expected number of doublets from the count of empty/nonempty cell barcodes
#' 
#' Given the count of empty and non-empty cell barcodes, fit data to a poisson distribution
#' where the empty count matches the number given, and the sum of counts >= 1 equals the non-empty count.
#' 
#' The number of nonEmpty cell barcodes is estimated by any cell selection software you'd like to use - 10x
#' and other scRNASeq methods will generate this number
#' 
#' The number of empty cell barcodes is slightly harder to estimate - it can be inferred using
#' cell level metrics of the number of UMIs and %intronic to find cell barcodes that have fewer UMIs and 
#' (in the case of nuclei) lower pct inronic.  See \code{\link{estimateEmptyCount}}
#' 
#' This estimates a lambda parameter for a Poisson distribution.  Assuming this distribution is reasonable,
#' it is them possible to estimate the doublet rate as the number of single observations divided by the number of
#' observations of one or more counts.
#' 
#' @param emptyCount The number of cell barcodes that do not encapsulate a cell in the experiment
#' @param nonEmptyCount The numbeYr of cell barcodes that encapsulate a cell in the experiment
#' @param showPlot Plot the poisson counts distribution using the inferred lambda parameter for the total number of cell barcodes.
#' 
#' @return A dataframe contain the input parameters, and the esimated doublet rate and lambda parameter.
#' @export
#' @import ggplot2
#' @examples estimateDoubletRatePoissonDistribution(10000,1000)
estimateDoubletRatePoissonDistribution<-function (emptyCount, nonEmptyCount, showPlot=TRUE) {
	
	#estimate the lambda to minimize difference between the observed counts of 0 and not 0 vs the counts from the poisson
	estimatePoisionGreaterThanZero<-function (lambda, fracNonZero) {
		#what is the cumulative probability of points with a count > 0?  IE: not empty
		estimatedFracNonZero=ppois(0, lambda, lower.tail = FALSE)
		#difference in observed and estimated, minimize the absolute difference.
		score=abs(fracNonZero-estimatedFracNonZero)
		#log_info(paste("Lambda [", lambda, "] score [", score, "]"), sep="")
		return(score)
	}
	
	total=emptyCount+nonEmptyCount
	fracNonZero=nonEmptyCount/total
	
	#an upper bound of 20 would have ~ 0 empty droplets.
	o=optim(par=1, fn=estimatePoisionGreaterThanZero, fracNonZero=fracNonZero, method="Brent", lower=0, upper=20)
	lambda=o$par
		
	#let's look at a maximum of 10 cells in a single droplet.
	success <- 0:10
	d=round (dpois(success, lambda=lambda)*total)
	df=data.frame(success=success, counts=d)
	fracDoublet=round (sum (df[df$success>1,]$counts)/sum (df[df$success>0,]$counts),3)
	summaryDF=data.frame(emptyCount=emptyCount, nonEmptyCount=nonEmptyCount, total=total, lambda=lambda, doubletRate=fracDoublet)
	
	#I hate making ggplot2 / R CMD check happy.
	counts<-NULL
	
	if (showPlot) {
		p=ggplot(df, aes(x=success, y=counts)) + 
			geom_bar(stat = "identity", fill="light blue") +
			geom_text(aes(label = counts), vjust = -0.5) +
			ggtitle(paste("Estimated Lambda [", round (lambda,3), "], Expected Fraction Doublets [", fracDoublet, "]")) +
			scale_x_continuous("", labels = as.character(success), breaks = success)
		print (p)
	}
	
	return (summaryDF)	
}

#' Estimate the number of empty cell barcodes in an experiment
#'
#' Manually draw thresholds around the ambient peak, and count the number of cells
#' 
#' @param cellMetricsFile A file containing one entry per cell.  The file is tab separated,
#' and the required columns are:
#' 1. cell_barcode - the string identifying the cell in the experiment.  Usually 12-16 bases long.
#' 2. num_transcripts - the total number of UMIs assigned to each cell.
#' 3. pct_intronic - the fraction of reads or UMIs that are intronic.
#' @param minPctIntronic The minimum PCT intronic for the ambient cell barcodes
#' @param maxPctIntronic The maximum PCT intronic for the ambient cell barcodes
#' @param minUMIs The minimum number of UMIs (in log10) for the ambient cell barcodes
#' @param maxUMIs The maximum number of UMIs (in log10) for the ambient cell barcodes
#'
#' @return The number of empty barcodes captured by the bounding box.
#' @export
estimateEmptyCount<-function (cellMetricsFile, minPctIntronic=0.28, maxPctIntronic=0.5, minUMIs=2.8, maxUMIs=3.3) {
	a=read.table(cellMetricsFile, header=T, stringsAsFactors = F, sep="\t")
	numEmpty=length(which(log10(a$num_transcripts)>minUMIs & log10(a$num_transcripts)<maxUMIs &
						  	a$pct_intronic<maxPctIntronic & a$pct_intronic>minPctIntronic))
	smoothScatter (log10(a$num_transcripts), a$pct_intronic, main=paste("Num empty cell barcodes [boxed selection] ", numEmpty))
	rect(xleft =minUMIs, ybottom= minPctIntronic, xright = maxUMIs, ytop = maxPctIntronic, col = "NA", lwd=2, border='red')  
	return (numEmpty)
}
	
	

#This is for R CMD CHECK
if(getRversion() >= "2.15.1")  utils::globalVariables(c("."))


#' Run standard analysis for census, roll call, and csi.
#' 
#' Run standard analysis for census, roll call, and csi.  
#' All input files are optional, plots will be generated based on the files that are not null.
#' 
#' While many inputs are optional, CensusSeq should be run in combination with RollCall and CSI to
#' fully evaluate a donor pool. 
#' @param readQualityMetricsFile A file containing the number of reads that aligned in the experiment. 
#' This file is generated by Picard's CollectMultipleMetrics. (optional)
#' @param censusFile The dropulation census output file
#' @param rollCallFile The Roll Call output file
#' @param csiFile The CSI output file
#' @param donorListFile A list of donors expected in the data set.
#' @param expName The name of the experiment.
#' @param outPDF A file location where plots will be generated. (optional)
#' @param minNumSNPS The minimum number of SNPs to consider a roll call result to be well powered.  
#' @export
#' @import grDevices graphics utils stats data.table
censusSeqQC<-function (readQualityMetricsFile=NULL, censusFile=NULL, rollCallFile=NULL, csiFile=NULL, donorListFile=NULL, expName="", outPDF=NULL, minNumSNPS=1000) {
    if (!is.null(outPDF)) pdf(outPDF)
    if (!is.null(readQualityMetricsFile)) plotReadQualityMetrics(readQualityMetricsFile, expName)
	if (!is.null(censusFile)) csiNumSNPsPlot(csiFile, expName)
	if (!is.null(rollCallFile) & !is.null(donorListFile)) plotRollCallNumSNPs(rollCallFile, donorListFile, minNumSNPS, expName)
	if (!is.null(rollCallFile) & !is.null(censusFile)) plotRollCall(rollCallFile, censusFile, donorListFile, expName)
	if (!is.null(rollCallFile) & !is.null(censusFile)) plotCensusRollCall(rollCallFile, censusFile, donorListFile, expName)
	if (!is.null(outPDF)) dev.off()
}


#Adding this plot back in.
plotCensusRollCall<-function (rollCallFile, censusFile, donorListFile, expName) {
	#TO make R CMD CHECK happy.  Blame ggplot2.
	REP_IRVs=CENSUS=NULL
	
	h=read.table(censusFile, comment.char = "@", nrows =1, fill=T, skip=1, sep="\t", stringsAsFactors = F)
	a=read.table(rollCallFile, header=T, stringsAsFactors=F, sep="\t")
	b=read.table(censusFile, header=T, stringsAsFactors = F, sep="\t")
	
	numCensus=dim (b)[1]
	
	#roll call and census can now be disjoint sets of donors when highly related donors are
	#removed from the roll call analysis, so need to match to the tested set.
	both=intersect (a$DONOR, b$DONOR)
	a=a[match(both, a$DONOR),]
	b=b[match(both, b$DONOR),]
	
	df=data.frame(DONOR=a$DONOR, REP_IRVs=a$REP_IRVs, NUM_SNPS=a$NUM_SNPS, CENSUS=b$REPRESENTATION, stringsAsFactors = F)
	
	allXY=c(df$REP_IRVs, df$CENSUS)
	allXY=allXY[allXY>0]
	xyLim=c(min(floor (log10(allXY))), max(ceiling (log10(allXY))))
	
	#for any value of 0, set to the minimum to avoid log10 issues.
	df$REP_IRVs[df$REP_IRVs==0]=min(allXY)
	
	#log10 data before plotting.
	df$REP_IRVs_log10=log10(df$REP_IRVs)
	df$CENSUS_log10=log10(df$CENSUS)
	
	p=ggplot(df, aes(x = log10(REP_IRVs), y = log10(CENSUS))) +
		geom_point() +
		scale_x_continuous(breaks = seq(xyLim[1], xyLim[2], by = 1), 
						   labels = function(x) as.character(10^x), limits=xyLim) +
		scale_y_continuous(breaks = seq(xyLim[1], xyLim[2], by = 1), 
						   labels = function(x) as.character(10^x), limits=xyLim) +
		labs(x = "Roll Call [log10]", y = "Census [log10]") +
		geom_abline(slope = 1, intercept = 0, color = "grey", linetype = "dashed") +
		geom_hline(yintercept = log10(0.003), color = "red", linetype = "dashed") +
		theme(axis.text.x = element_text(size = 10), 
			  axis.text.y = element_text(size = 10),
			  axis.title = element_text(size = 12),
			  plot.title = element_text(size = 14))
		
	
	#add census converged info.
	strTitle2=""
	strTitle3=""
	if (h$V3=="CONVERGED=false") strTitle2="Census did not converge"
	#if roll call didn't ascertain all individuals
	if (numCensus>length(both)) {
		strTitle3=paste("Samples Ascertained: Roll Call [", length(both),"] Census [",  numCensus, "]")
	}
	p=p+ggtitle (paste(expName, "\n", strTitle2, "\n", strTitle3))
	print (p)
}

plotRollCallNumSNPs<-function (rollCallFile, donorListFile, minNumSNPS=1000, expName) {
	#TO make R CMD CHECK happy.  Blame ggplot2.
	order_index=NUM_SNPS=categoryNames=NULL
	
	a=read.table(rollCallFile, header=T, stringsAsFactors = F, sep="\t")
	samples=read.table(donorListFile, header=F, stringsAsFactors = F, sep="\t")$V1
	a$IN_POOL=F
	a$SUFFICIENT_SNPS=F
	if (any(a$NUM_SNPS>=minNumSNPS)) a[a$NUM_SNPS>=minNumSNPS,]$SUFFICIENT_SNPS=T
	#donors can be missing from the sample list because they are highly related.
	#limit sample list to donors tested.
	samples=intersect(samples, a$DONOR)
	a[match(samples, a$DONOR),]$IN_POOL=T
	a=a[order (a$IN_POOL, a$NUM_SNPS),]
	getCol<-function (x) {
		if (x[["IN_POOL"]]==F && x[["SUFFICIENT_SNPS"]]==F) return ("orange")
		if (x[["IN_POOL"]]==F && x[["SUFFICIENT_SNPS"]]==T) return ("red")
		if (x[["IN_POOL"]]==T && x[["SUFFICIENT_SNPS"]]==F) return ("blue")
		if (x[["IN_POOL"]]==T && x[["SUFFICIENT_SNPS"]]==T) return ("green")
	}
	
	a$colors=as.vector(apply(a[c("IN_POOL", "SUFFICIENT_SNPS")], 1, getCol))
	
	# Reorder factor levels to maintain sorting within categories
	# Create an index for ordering
	# Sort the data frame by color and NUM_SNPS
	a <- a[order(a$colors, a$NUM_SNPS), ]
	
	# Create an index for ordering
	a$order_index <- 1:dim(a)[1]
	
	p=ggplot(a, aes(x = order_index, y = log10(NUM_SNPS), fill=colors )) +
		geom_bar(stat = "identity", aes(colour=colors), show.legend=T) +
		labs(x = "Donors", y = "Num SNPs", fill = "Category") +
		theme_minimal() +
		scale_color_identity() +
		scale_fill_manual(values = c("blue", "green", "orange", "red"),
						  labels = c("in pool insufficient SNPs", "in pool sufficient SNPs",
									"outside pool insufficient SNPs", "outside pool sufficient SNPs")) +
		ggtitle(paste(expName, "\nSNPs ascertained by Roll Call in Pool")) +
		theme(legend.position = "top") +
		guides(fill=guide_legend(nrow=2,byrow=TRUE))
	print (p)
	
	# Calculate counts
	counts <- c(
		sum(a$IN_POOL == TRUE & a$SUFFICIENT_SNPS == FALSE),
		sum(a$IN_POOL == TRUE & a$SUFFICIENT_SNPS == TRUE),
		sum(a$IN_POOL == FALSE & a$SUFFICIENT_SNPS == FALSE),
		sum(a$IN_POOL == FALSE & a$SUFFICIENT_SNPS == TRUE)
	)
	
	# Create a data frame for plotting
	plot_data <- data.frame(categoryNames = c("in pool insufficient SNPs", "in pool sufficient SNPs",
											  "outside pool insufficient SNPs", "outside pool sufficient SNPs"),
							counts = counts)
	
	p= ggplot(plot_data, aes(y = categoryNames, x = counts)) +
		geom_bar(stat = "identity", fill = "lightblue") +
		geom_text(aes(label = counts, x = max(counts) / 2), hjust=0.5, size = 7) +
		labs(x = "Counts", y = NULL) +
		ggtitle(paste(expName, "\nSNPs ascertained by Roll Call")) +
		theme_minimal() +
		theme(axis.text.y = element_text(angle = 0, hjust = 0.5, vjust = 0.5))
	print (p)
}

csiNumSNPsPlot<-function (csiFile, expName) {
	#TO make R CMD CHECK happy.  Blame ggplot2.
	values=NULL
	
    h=read.table(csiFile, comment.char = "@", nrows =1, fill=T, skip=1, sep="\t")
    a=read.table(csiFile, header=T, stringsAsFactors = F ,sep="\t")
    aa=c(a$NUM_SNPS, a$REF_COUNT, a$ALT_COUNT)
    
    df=data.frame(SNPs=a$NUM_SNPS, "Ref Alleles"=a$REF_COUNT, "Alt Alleles"=a$ALT_COUNT, check.names = F)
    
    categories = c("SNPs", "Ref Alleles", "Alt Alleles")
    plot_data <- data.frame(categories = categories, values = aa)
    plot_data$categories=factor(plot_data$categories, levels=categories)
    
    fracAltStr=paste("(", round (a[['FRAC_ALT']]*100,3), "%)", sep="")
    strTitle=paste(expName, "- CSI summary\n", "% Contamination [", round (a$PCT_CONTAMINATION,2), "]",  sep="")
    
    p=ggplot(plot_data, aes(x = categories, y = values)) +
    	geom_bar(stat = "identity", fill = "lightblue") +
    	geom_text(aes(label = ifelse(categories == "Alt Alleles", a$ALT_COUNT, ""), y= max(df)/2), 
    			  position = position_dodge(width = .9), vjust = 0.5, size=6) +
    	geom_text(aes(label = ifelse(categories == "Alt Alleles", fracAltStr, ""), y= max(df)/3), 
    			  position = position_dodge(width = .9), vjust = 0.5, size=6) +
    	theme(axis.text.x = element_text(size = 14), 
    		  axis.text.y = element_text(size = 10),
    		  axis.title = element_text(size = 12),
    		  plot.title = element_text(size = 16)) +
    	ggtitle(strTitle) +
    	labs(x = "", y = "")
    
    print (p)
    
}

plotReadQualityMetrics<-function (readQualityMetricsFile, expName) {
	#TO make R CMD CHECK happy.  Blame ggplot2.
	values=NULL
	
    a=read.table(readQualityMetricsFile, header=T, stringsAsFactors=F, sep="\t", nrows=3)
    if (dim(a)[1]>1) {
        a=a[a$CATEGORY=="PAIR",]
    }
    aa=a[,c("PF_READS", "PF_READS_ALIGNED", "PF_HQ_ALIGNED_READS")]
    aa=round (as.numeric(aa)/1e6,1)
    z=barplot (aa, col="light blue", names.arg=c("total", "aligned", "HQ aligned"), ylab="Reads [millions]", cex.axis=1.5, cex.lab=1.5, cex.names = 1.5)
    pct=paste (round (aa/max(aa)*100,1), "%")
    text (z[,1], max(aa)/2, labels=pct, cex=2)
    title(expName, cex.main=1.5)
    
    categories = c("total", "aligned", "HQ aligned")
    plot_data <- data.frame(categories = categories, values = aa, pct=pct)
    plot_data$categories=factor(plot_data$categories, levels=categories)
    
    ggplot(plot_data, aes(x = categories, y = values)) +
    	geom_bar(stat = "identity", fill = "lightblue") +
    	geom_text(aes(label = pct), vjust = 0, y=max(plot_data$values)/2, size=8) +
    	theme(axis.text.x = element_text(size = 14), 
    		  axis.text.y = element_text(size = 10),
    		  axis.title = element_text(size = 14),
    		  plot.title = element_text(size = 16)) +
    	ggtitle(expName) +
    	labs(x = "", y = "Reads [millions]")
    
}


#############################################################################
# Dmeyer Roll Call plot code.
# This could would be nice to simplify somewhat.
#############################################################################

plotRollCall<-function (rollCallFile, censusFile, donorListFile, expName) {
	h=read.table(censusFile, comment.char = "@", nrows =1, fill=T, skip=1, sep="\t", stringsAsFactors = F)
	
	#add census converged info.
	strTitle2=""
	if (h$V3=="CONVERGED=false") {
		title (paste(expName, "\n", strTitle2))
	} else {
		preppedRollcallData <- prepareRollcallData(rollCallFile,donorListFile,expName)
		print(plotRollcalls(preppedRollcallData,logScale=TRUE, flipAxes=TRUE,colors= c("black","#4594f5")))
	}
}


#' Plotting of rollcall data
#'
#' @param preppedRollcallData dataframe containg rollcall data generated using
#' \code{\link{prepareRollcallData}}
#' @param labelOutliers logical flag set to label any "intruders" or "no-shows"
#' @param logScale logical flag set to log-transform data
#' @param jitterHeight How much to jitter the plot vertically
#' @param pointsAlpha Transparency of points
#' @param labelAlpha Transparency of labels
#' @param labelSize Font size of labels
#' @param flipAxes logical flag to orient x/y axes. Defaults to FALSE, with REP_IRVs on the x-axis
#' @param colors colors for different classes (Expected, [Possible], Unexpected)
#'
#' @return ggplot object of plot for given rollcall data
#'
#' @import ggplot2
#' @importFrom ggrepel geom_label_repel
#' @importFrom data.table rbindlist
#' @importFrom purrr compose
#' @noRd
plotRollcalls <- function(preppedRollcallData, labelOutliers=F, logScale=F, 
                          jitterHeight=0.2, 
                          pointsAlpha=0.5,
                          labelAlpha=0.7,
                          labelSize=5,
                          flipAxes=FALSE,
                          colors=c("black", "#d18017", "red")) {

	
	#TO make R CMD CHECK happy.  Blame ggplot2.
	ID=REP_IRVs=NUM_SNPS=DONOR=Expected=isOutlier=NULL
	
	if (is.list(preppedRollcallData))
    	preppedRollcallData <- rbindlist(preppedRollcallData)

	#avoid warnings when REP_IRV=0 and Y axis on log scale by adding a small number.
	if (logScale) {
		smallNumber=min (preppedRollcallData[preppedRollcallData$REP_IRVs>0,]$REP_IRVs)/2
  		preppedRollcallData$REP_IRVs=preppedRollcallData$REP_IRVs+smallNumber
	}
  	
  
	# Check how many levels preppedData$Expected has
	nLevels <- length(unique(levels(preppedRollcallData$Expected)))
	if (nLevels == 2 && length(colors) == 3) colors <- colors[-2]

	jitterpos <- ggplot2::position_jitter(width=0,height = jitterHeight, seed=2)
  
	# Set ID as factor. Reverse if ID is on the y-axis (default)
	preppedRollcallData$ID <- (function(x) { 
       dirFun=ifelse(flipAxes, identity, rev)
       lvls=purrr::compose(dirFun, unique,as.character)(x)
       return (factor(x, lvls))
    })(preppedRollcallData$ID)
           
	p <- ggplot2::ggplot(preppedRollcallData, 
        	aes(y=ID, x=REP_IRVs, size=NUM_SNPS, label=DONOR, color=Expected)) +
    		geom_jitter(alpha=pointsAlpha, position = jitterpos)
	if (labelOutliers) {
    	toLabel <- preppedRollcallData[isOutlier,]
    	p <- 
    	p + geom_label_repel(data=toLabel, position=jitterpos, size=labelSize, 
                           alpha=labelAlpha, min.segment.length=0, force=T)
	}
	if (logScale)
    	p <- p + scale_x_continuous(trans='log10') + labs(x="REP_IRVs [log10]")

	p <- p+labs(color='', y='')+
    	scale_color_manual(values = colors)+
    	theme_linedraw()
	if (flipAxes)
    	p <- p + coord_flip()
	return (p)
}


### Data preparation functions ###

#' Preparation of rollcall data to be done before plotting
#'
#' @param rollcallFiles character vector of rollcall file paths
#' @param donorFiles character vector of line-separated donor files
#' containing a subset of donors from the VCF with which rollcall
#' was run.
#' @param ids labels given to eah rollcall dataset. Added as ID column.
#'
#' @return list of pepared rollcall dataframes
#' @noRd
prepareRollcallData <- function(rollcallFiles, donorFiles, ids=NULL) {
  validateRollcallFiles(rollcallFiles, donorFiles)

  ids <- validateAndExtractIds(rollcallFiles, ids)
  rollcallDfs <- loadRollcallFilesWithIds(rollcallFiles, ids)
  expectedDonors <- lapply(donorFiles, readLines)

  rollcallDfsWithExpectedDonors <- 
    mapply(annotateExpectedDonors, rollcallDfs, expectedDonors, SIMPLIFY=FALSE)

  result <- rollcallDfsWithExpectedDonors 
  names(result) <- ids
  return (result)
}



### Validation functions ###

#' Loading of rollcall file and addition of column specifying an ID for it
#'
#' @param rollcallFiles character vector of rollcall files
#' @param ids character vector of ids to assign to data from each rollcall file,
#' added as a new column ID to the parsed contents of each rollcall file
#' @importFrom data.table fread
#' @noRd
loadRollcallFilesWithIds <- function(rollcallFiles, ids) {
  loadSingleFileWithId <- function(file, id) {
    res <- fread(file)
    res$ID <- id
    return (res)
  }
  mapply(loadSingleFileWithId, rollcallFiles, ids, SIMPLIFY=FALSE)
}


#' Validation of ids variable if provided, extraction of ids if NULL
#'
#' @param rollcallFiles A list of roll call files to process 
#' @param ids The experiment or pool names for the roll call files.  Should be 
#' the same length as the rollcallFiles parameter and all entries must be unique
#' @importFrom stringr str_remove
#' @noRd
validateAndExtractIds <- function(rollcallFiles, ids) {
  if (is.null(ids))
    ids <- str_remove(basename(rollcallFiles), ".roll_call.txt$")
  else if (length(ids) != length(unique(ids)))
    stop("All ids must be unique")
  else if (length(ids) != length(rollcallFiles))
    stop("Must provide one id per rollcall file or set `ids` to NULL")
  return (ids)
}

#' Validation of the existence of files
#'
#' @param filepaths character vector of filepaths to validate
#' @noRd
validateFilepaths <- function(filepaths) {
  validFiles <- file.exists(filepaths)
  if (!all(validFiles)) {
    stop(paste("The following provided files do not exist:", 
               paste('"',filepaths,'"', collapse=",", sep="")))
  }
}

#' Validation of files needed to prepare a rollcall dataset
#'
#' @param rollcallFiles character vector of rollcall files to validate
#' @param donorFiles character vector of donor files to validate 
#' @noRd
validateRollcallFiles <- function(rollcallFiles, donorFiles) {
  if (length(rollcallFiles) != length(donorFiles)) {
    if (length(donorFiles) != 1) {
      stop(paste("`rollcallFiles` and `donorFiles` must be of same",
                 "length unless donorFiles is of length 1"))
    }
  }
  validateFilepaths(rollcallFiles)
  validateFilepaths(donorFiles)
}


### Annotation functions ###

#' Annotation of whether or not donors were expected to show up as present in
#' rollcall
#' 
#' @param rollcallDf dataframe containing rollcall results
#' @param expectedDonors character vector containing subset of donors from 
#' the VCF with which rollcall was run.
#' @return list of rollcall dataframes with added `Expected` column
#' to specify whether or not the sample was in the list of expected donors
#' @noRd
annotateExpectedDonors <- function(rollcallDf, expectedDonors) {
  rollcallDf$Expected <- 
    factor(ifelse(rollcallDf$DONOR %in% expectedDonors, "Expected", "Unexpected"),
           c("Expected", "Unexpected"))
  return (rollcallDf)
}

# MIT License
#
# Copyright 2018 Broad Institute
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.


#This is for R CMD CHECK
if(getRversion() >= "2.15.1")  utils::globalVariables(c("."))


plotCellsByProbabilityNew<-function(df, fdrThreshold=0.05) {
	#TO make R CMD CHECK happy.  Blame ggplot2.
	FDR_pvalue=NULL
	
	plotOne<-function (a, strTitle) {
		p=ggplot(a, aes(x = log10(FDR_pvalue))) +
			geom_histogram(bins = 100, fill = "skyblue", color = "black") +
			labs(title = strTitle, x = "FDR p-value [log10]", y = "Frequency") +
			theme(plot.title = element_text(size = 14), 
				  axis.text = element_text(size = 10), 
				  axis.title = element_text(size = 12))
		print (p)
	}
	
	
    totalNumCells=dim(df)[1]
    strTitle=paste("All FDR corrected pvalues\n", round(length(which(df$FDR_pvalue< fdrThreshold))/dim(df)[1]*100,1), "% of cells with FDR < ", fdrThreshold)
    plotOne(df, strTitle)
    
    #remove doublets.
    cellsToKeep=df[df$label_simple=="singlet",]$cell_barcode
    
    if (!is.null(cellsToKeep) & length(cellsToKeep)>0 ) {
        idx=sort(match(cellsToKeep, df$cell_barcode))
        if (length(idx)>0) {
        	a=df[idx,]
        	cellsPassFDR=length(which(a$label=="single_pass_FDR"))
        	pct=paste(round(cellsPassFDR/totalNumCells*100,1), "% of cells", sep="")
        	strTitle=paste("All FDR corrected pvalues after filtering doublets\n", pct, "[", cellsPassFDR, "/", dim(a)[1], "] with FDR < ", fdrThreshold)
        	plotOne(a, strTitle)
        	
        }
    }
}

validateFilesExist<-function (likelihoodSummaryFile, doubletLikelihoodFile, dgeRawSummaryFile, dgeSummaryFile, censusFile, expectedSamplesFile) {
    f<-function (x) {
        vName=deparse(substitute(x))
        if (!is.null(x)) {
            if (!file.exists (x)) {
                stop((paste(vName, "is not null and is missing")))
            }
        }
    }
    f(likelihoodSummaryFile)
    f(doubletLikelihoodFile)
    f(dgeRawSummaryFile)
    f(dgeSummaryFile)
    f(censusFile)
    f(expectedSamplesFile)
}

#calculate the probability of being a singlet.
#returns cells unlikely to be a singlet (AKA some doublet.)
plotDoubletProbability<-function (df, expName="", summaryStats, doubletPvalueThreshold=0.9) {
	#TO make R CMD CHECK happy.  Blame ggplot2.
	doublet_pval=NULL
	
	idx=which(df$label_simple=="singlet")
	
    numSinglets=length(idx)
    pctSinglets=round (numSinglets/dim (df)[1]*100,1)
    
    # Create the histogram
    
    # There's a error with the new ggplot2 code (V 3.5) where this produces a warning if you use geom_segment directly.
    # This is similar to: https://github.com/tidyverse/ggplot2/issues/5762
    # Using hacky fix for now.
    p=ggplot(df, aes(x = doublet_pval)) +
    	geom_histogram(bins = 100, fill = "skyblue", color = "black", show.legend = FALSE) +
    	labs(x = "Doublet Probability", y = "Frequency") +
    	ggtitle(paste(expName, "\nCells remaining [", numSinglets, "] [", pctSinglets, "%]")) +
    	annotate("segment", x =doubletPvalueThreshold , y = 0, xend = doubletPvalueThreshold, yend = Inf, colour = "red") + 
    	annotate("text", x = 0.5, y = Inf, label = paste("Confident doublet rate", round(summaryStats$pct_confident_doublets, 2), "%"),hjust = 0.5, vjust = 2, size = 7) +
    	theme(plot.title = element_text(size = 14, hjust = 0.5, face="bold"), axis.text = element_text(size = 12), axis.title = element_text(size = 12))
    
    print (p)
}

plotCommonDonors<-function (df, minimumFractionDonor=0.005) {
	#TO make R CMD CHECK happy.  Blame ggplot2.
	index=value.Freq=NULL
	
    plotOne <- function(r, cex.axis = 0.5, main) {
    	# Exit early if there's no data.
    	if (length(r) == 0) return(NULL)
    	
    	# Create a data frame from the input vector
    	df <- data.frame(index = seq_along(r), value = r)
    	
    	maxY=max (df$value.Freq)*1.1
    	
    	# Define plot aesthetics
    	p <- ggplot(df, aes(x = index, y = value.Freq)) +
    		geom_line(linetype="dashed") +   # Add lines
    		geom_point(size=4) + 
    		labs(x = "", y = "Number of cells assigned to donor") +
    		scale_x_continuous(breaks = seq_along(r), labels = names(r), minor_breaks = NULL) +
    		scale_y_continuous(expand = c(0, 0), limits = c(0, maxY)) +
    		ggtitle(main) +
    		theme(axis.text.x = element_text(angle = 90, vjust = 0.5, size = 10), 
    			  axis.text.y = element_text(size = 10),
    			  axis.title = element_text(size = 12),
    			  plot.title = element_text(size = 14)) +
    		theme(panel.background = element_rect(colour = "black"))
    		
		print (p)
    }

    result=df[df$label=="single_pass_FDR",]
    rUnfiltered=sort(table(result$donor), decreasing=T)

    minNum=sum(rUnfiltered)* minimumFractionDonor
    rFiltered=rUnfiltered[rUnfiltered>minNum]

    plotOne(rUnfiltered, cex.axis=0.75, main=paste("All Donor Assignments seen at least once\n[FDR passing cells] [", sum(rUnfiltered), "]"))
    plotOne(rFiltered, cex.axis=0.75, main =paste("Common Single Donor Assignment\n[FDR passing cells] [", sum(rFiltered), "]"))
	
    df=data.frame(donor=names(rFiltered), count=as.numeric(rFiltered), stringsAsFactors=F)
    df2=result[,c("cell_barcode", "donor")]

    #filter df2 to be consistent with rFiltered
    df2=df2[df2$donor %in% names(rFiltered),]
    #change column names to expected
    colnames(df2)=c("cell", "bestSample")
    result=list(summary=df, cellDonorMap=df2)
    return (result)

}

plotCommonDonorAssignmentsWithUnexpected<-function (donors, es, expName) {
	#TO make R CMD CHECK happy.  Blame ggplot2.
	index=count=expected=NULL
	
	#Skip this plot if there's no data.
	if (dim (donors)[1]==0) return (NULL)
	
	idx=match(donors$donor, es$V1)
	donors$expected=T
	if (any(is.na(idx))) donors[is.na(idx),]$expected=F
	missing=setdiff(es$V1, donors$donor)
	if (length(missing)>0) {
		d2=data.frame(donor=missing, count=0, expected=T)
		d2=rbind(donors, d2)
	} else {
		d2=donors
	}
	
	plotOne<-function (d2, expName="") {
		d=vegan::diversity(d2$count)
		eq=d/log(dim(d2)[1])
		strTitle=paste (expName, "\n", "SW Div: ", sprintf("%.2f",round(d,2)), "; SW Eq: ", sprintf("%.2f", round (eq,3)), sep="")
		d2$index=1:dim(d2)[1]
		maxY=max(d2$count)*1.1
		p=ggplot(d2, aes(x = index, y = count, color = expected)) +
			geom_line(linetype = "dashed", color = "black") +   # Add lines
			geom_point(data = d2, aes(color = expected), size = 4) +
			labs(x = "", y = "Number of cells assigned to donor", color = "Expected") +
			scale_x_continuous(breaks = seq(from = 1, to = dim(d2)[1]), labels = d2$donor, minor_breaks = NULL) +
			scale_y_continuous(expand = c(0, 0), limits = c(0, maxY)) +
			ggtitle(strTitle) +
			theme(axis.text.x = element_text(angle = 90, vjust = 0.5, size = 10), 
				  axis.text.y = element_text(size = 10),
				  axis.title = element_text(size = 12),
				  plot.title = element_text(size = 14),
				  legend.position = c(0.8, 0.8)) +
				  # This is for ggplot 3.5, which we don't want to force yet.
#				  legend.position = "inside", legend.position.inside = c(0.8, 0.8)) +
			theme(panel.background = element_rect(colour = "black")) +
			scale_color_manual(values = c("black", "red"), 
							   breaks = c(TRUE, FALSE),
							   labels = c("EXPECTED", "UNEXPECTED"),
							   name="Donor Status")	
		print (p)	
	}
	
	plotOne(d2, expName)
	
}


#' Plot the single cell FDR distribution of each donor
#'
#' @param df The data frame generated by getSingletDoubletDF
#' @inheritParams donorAssignmentQC
#' @noRd
plotCommonDonorsFdrDistribution<-function (df, minimumFractionDonor=0.005) {
	#TO make R CMD CHECK happy.  Blame ggplot2.
	donor=FDR_pvalue=label=value=NULL
	
	# Subset the data
	rUnfiltered=sort(table(df[df$label_simple=="singlet",]$donor), decreasing=T)
	
	minNum=sum(rUnfiltered)* minimumFractionDonor
	rFiltered=rUnfiltered[rUnfiltered>minNum]
	commonDonors=names (rFiltered)
	
	subset_data=df[df$donor %in% commonDonors,]
	
	# Create the boxplot with -log10 transformation
	ggplot(subset_data, aes(x = donor, y = -log10(FDR_pvalue))) +
		geom_violin() +
		labs(x = "Donor", y = "-log10(FDR p-value)") +
		ggtitle("Singlet cell -log10(FDR p-values) distribution for each common donor")
	
}

plotCensusComparison<-function (censusFile, summary, expName) {

    summary$frac=summary$count/sum(summary$count)
    census=read.table(censusFile, header=T, stringsAsFactors=F)

    both=union (summary$donor, census$DONOR)
    summary=summary[match(both,summary$donor),]
    summary$donor=both
    idx=which(is.na(summary$frac))
    if (length(idx)>0) summary[idx,]$frac<-0

    census=census[match(both, census$DONOR),]
    census$DONOR=both
    idx=which(is.na(census$REPRESENTATION))
    if (length(idx)) census[idx,]$REPRESENTATION<-0

    idx=match(summary$donor, census$DONOR)
    census=census[idx,]

    df=data.frame(donor=summary$donor, dropulation=summary$frac, census=census$REPRESENTATION, stringsAsFactors = F)
    df$foldChange=exp(abs(log(df$census/df$dropulation)))
    foldChangeScore=exp (median (abs(log(df$census/df$dropulation))))
    lim=max(c(df$dropulation,df$census))

    par(mar=c(5, 4, 4, 2) + 0.1)
    plot (df$dropulation, df$census, xlim=c(0, lim), ylim=c(0, lim), xlab="dropulation", ylab="census", cex.axis=1.5, cex.lab=1.5, pch=16, cex=2)
    title(sub=paste("Median fold change: ", round(foldChangeScore, 3)))
    title(paste(expName, "Dropulation and Census Results"))
    abline(0,1, col='red', lty=2)
    return (df)
}

calculateReadsPerUMI<-function (readsPerCellFile=NULL, dgeSummaryFile=NULL, cellDonorMap) {
	#if there's no data, exit and return NA.
	if (dim(cellDonorMap)[1]==0)
		return (NA)
	
	if (is.null(readsPerCellFile) | is.null(dgeSummaryFile))
		return (NA)
	
    a=read.table(readsPerCellFile, header=F, stringsAsFactors = F)
    ds=read.table(dgeSummaryFile, header=T, stringsAsFactors = F)
    idx=match(cellDonorMap$cell, ds$CELL_BARCODE)
    ds=ds[idx,]
    idx=match(ds$CELL_BARCODE, a$V2)
    a=a[idx,]
    #plot (a$V1, ds$NUM_TRANSCRIPTS, xlab="reads", ylab="UMIs")
    readsPerUMI=a$V1/ds$NUM_TRANSCRIPTS
    readsPerUMI=readsPerUMI[!is.na(readsPerUMI)]
    medianReadsPerUMI=median(readsPerUMI)

    df=data.frame(readsPerUMI=readsPerUMI)
    p=ggplot(data=df, aes(y = readsPerUMI, x=0)) +
    	geom_boxplot(width=0.35) +
    	labs(
    		title = paste("Reads per UMI in assigned singleton cells\nMedian=", round(medianReadsPerUMI, 2)),
    		y = "Reads/UMIs"
    	) +
    	ylim(0, max(df$readsPerUMI)) +
    	xlim(-1,1) +
    	theme(axis.title.x = element_blank(), axis.text.x = element_blank(), axis.ticks.x = element_blank())
    	
    print (p)	
    
    return (medianReadsPerUMI)

}

calculateMeanUMIsPerDonor<-function (expName, cellDF, dgeSummaryFile=NULL, donors, cellsToKeep=NULL) {
	#TO make R CMD CHECK happy.  Blame ggplot2.
	donor=medianUMIs=label=variable=totalUMIs=count=NULL
	
	#if there's no data quit early.
	if ((!is.null(cellsToKeep) & length(cellsToKeep)==0) | is.null(dgeSummaryFile)) {
		r=list(stats=data.frame(diversity=NA, equitability=NA), donors=donors)
		return (r)
	}
		
	df=data.table::copy(cellDF)
    if (!is.null(cellsToKeep)) {
        idx=sort(match(cellsToKeep, df$cell_barcode))
        if (length(idx)>0) df=df[idx,]
    }
	
	#filter to the final donor list (which may be filtered)
    idx=which(!is.na(match(df$donor, donors$donor)))
    df=df[idx,]
    
    #if there's no data, 
    dge=read.table(dgeSummaryFile, header=T, stringsAsFactors=F, check.names=F)
    
    getUMIsPerDonor<-function (donor, df, dge) {
        cellBarcodes=df[df$donor==donor,]$cell_barcode
        dgeDonor=dge[match(cellBarcodes, dge$CELL_BARCODE),]
        return (list(dgeDonor$NUM_TRANSCRIPTS))
    }

    umisPerDonor=sapply(donors$donor, getUMIsPerDonor, df, dge)
    medianUMisPerDonor=unlist(lapply(umisPerDonor, median, na.rm=T))
    medianAbsoluteDeviationPerDonor=unlist(lapply(umisPerDonor, mad, na.rm=T))
    totalUMIsPerDonor=unlist(lapply(umisPerDonor, sum, na.rm=T))

    sortedIndex=sort(medianUMisPerDonor, index.return=T)$ix

    umisPerDonor= umisPerDonor[sortedIndex]
    medianUMisPerDonor= medianUMisPerDonor[sortedIndex]
    totalUMIsPerDonor=totalUMIsPerDonor[sortedIndex]

    #add to dataframe.
    idx=match(donors$donor, names(medianUMisPerDonor))
    donors$medianUMIs=unlist(medianUMisPerDonor)[idx]
    idx=match(donors$donor, names(medianAbsoluteDeviationPerDonor))
    donors$medianAbsoluteDeviation=unlist(medianAbsoluteDeviationPerDonor)[idx]
    idx=match(donors$donor, names(totalUMIsPerDonor))
    donors$totalUMIs=unlist(totalUMIsPerDonor)[idx]
	
    #order the data by median UMI from smallest to largest.
    donors=donors[order(donors$medianUMIs),]    
    donors$donor=factor(donors$donor, levels=donors$donor)
    maxY=max(donors$medianUMIs)*1.1
    
    p=ggplot(donors, aes(x = donor, y = medianUMIs)) +
    	geom_point(size = 4) +
    	scale_y_continuous(expand = c(0, 0), limits = c(0, maxY)) +
    	labs(x = "", y = "median UMIs per donor") +
    	ggtitle(expName) +
    	theme(axis.text.x = element_text(angle = 90, vjust = 0.5, size = 10),
    		  axis.text.y = element_text(size = 10),
    		  axis.title = element_text(size = 12),
    		  plot.title = element_text(size = 14),
    		  legend.position = c(0.8, 0.8)) +
    	theme(panel.background = element_rect(colour = "black"))
	print (p)
    
	
	#stack up the UMIs per donor into a dataframe suitable for ggplot2
    df=stack(umisPerDonor)
    names(df) <- c("umisPerDonor", "donor")
    
    sortedDonorNames=names (sort (tapply(df$umisPerDonor, FUN=median, INDEX=df$donor)))
    df$donor=factor(df$donor, levels=sortedDonorNames)
    
    plotOne<-function (df, expName, maxY=NULL) {
    	if (is.null(maxY))
    		maxY=max(df$umisPerDonor)
    	p=ggplot(data=df, aes(x=donor, y = umisPerDonor)) +
    		geom_boxplot() +
    		labs(y = "UMIs") +
    		ggtitle(expName) +
    		coord_cartesian(ylim=c(0, maxY)) +
    		theme(axis.text.x = element_text(angle = 90, vjust = 0.5, size = 10), 
    			  axis.text.y = element_text(size = 10),
    			  axis.title = element_text(size = 12),
    			  plot.title = element_text(size = 14))
    	print (p)
    }
    
    #plotOne(df, expName)
    #plotOne(df, expName, maxY=2*max(unlist(medianUMisPerDonor)))
    
    #donor UMI distribution
    d=vegan::diversity(donors$totalUMIs)
    eq=d/log(dim(donors)[1])
	
    donors=donors[order(donors$totalUMIs, decreasing = T),]    
    donors$donor=factor(donors$donor, levels=donors$donor)
    
    strTitle=paste("Distribution of UMIs across donors\n",dim (donors)[1], " donors; ", round (sum (donors$totalUMIs)/1e6,1), "M UMIs; SW Div: ", sprintf("%.2f",round(d,2)), "; SW Eq: ", sprintf("%.2f", round (eq,3)), sep="")

    p=ggplot(donors, aes(x = donor, y = totalUMIs / 1e6, fill = 'light blue')) +
    	geom_bar(stat = "identity", color = "black") +
    	labs(y = "Total UMIs [millions]", x = "", fill = "") +
    	ggtitle(strTitle) +
    	scale_fill_identity() +
    	theme(axis.text.x = element_text(angle = 90, vjust = 0.5, size = 10), 
    		  axis.text.y = element_text(size = 10),
    		  axis.title = element_text(size = 12),
    		  plot.title = element_text(size = 14))
    
    print (p)
    
    p=ggplot(donors, aes(x = count, y = medianUMIs)) +
    	geom_point(size = 4) +
    	labs(x = "number of cels per donor", y = "median UMIs per donor") +
    	coord_cartesian(ylim=c(0, max (donors$medianUMIs)*1.1)) +
    	ggtitle(expName) +
    	theme(axis.text.x = element_text(size = 10), 
    		  axis.text.y = element_text(size = 10),
    		  axis.title = element_text(size = 12),
    		  plot.title = element_text(size = 14)) +
    	theme(panel.background = element_rect(colour = "black"))
    
    print (p)	
        
    r=list(stats=data.frame(diversity=d, equitability=eq), donors=donors)
    return (r)
}


# Why a pre-cellbender DGE file?
# Donor assignment does not benefit from UMI cleanup that is performed by cellbender,
# so we need the denominator to reflect the number of UMIs in the experiment that donor assignment 
# has access to.
plotRatioUMIsCaptuedToCellSize<-function (dgeRawSummaryFile, cellDF, cellsToKeep=NULL) {
	#TO make R CMD CHECK happy.  Blame ggplot2.
	density=.x=NUM_TRANSCRIPTS=fractionSNPUMIs=donor=NULL
	
	#quit early if no data.
	if ((!is.null(cellsToKeep) & length(cellsToKeep)==0) | is.null(dgeRawSummaryFile))
		return (NULL)
	
    dge=read.table(dgeRawSummaryFile, header=T, stringsAsFactors=F, sep="\t")
    df=data.table::copy(cellDF)
    if (!is.null(cellsToKeep)) {
        idx=sort(match(cellsToKeep, df$cell_barcode))
        if (length(idx)>0) df = df[idx,]
       
    }

    idx=match(dge$CELL_BARCODE, df$cell_barcode)
    
    dge$snpUMIs=df[idx,]$singlet_num_inform_umis
    dge$donor=df[idx,]$donor
    dge$likePerUMI=df[idx,]$best_like/df[idx,]$singlet_num_inform_umis
    dge$fractionSNPUMIs=dge$snpUMIs/dge$NUM_TRANSCRIPTS
    idxNA=which(is.na(dge$snpUMIs))
    if (length(idxNA)>0) dge=dge[-idxNA,]

    # after_stat(!!str2lang("density")) is a replacement for using ..density.. that doesn't make R CMD check mad.
    # https://stackoverflow.com/questions/74756655/how-to-replace-the-dot-dot-notation-in-ggplot2geom-histogramy-density
    
    plotHistWithlog10Axis <- function(df, var, xlab, ylab, main, xLims) {
    	p=ggplot(df, aes(x = !!sym(var))) + 
    		geom_histogram(aes(y = after_stat(!!str2lang("density"))), bins = 100, colour = 1, fill = "white") +
    		geom_density() +
    		scale_x_log10(labels = scales::trans_format('log10', scales::math_format(10^.x)), limits=xLims) +
    		labs(x = xlab, y = ylab, title = main) +
    		theme(axis.text.x = element_text(angle = 90, vjust = 0.5, size = 10), 
    			  axis.text.y = element_text(size = 10),
    			  axis.title = element_text(size = 12),
    			  plot.title = element_text(size = 14))
    	
    	return (p)
    }
    
    maxXLog10=ceiling(log10(max(dge$NUM_TRANSCRIPTS, dge$singlet_num_inform_umis)))+1
    xLims=c(1, 10^maxXLog10)
    p1=plotHistWithlog10Axis(dge, var='NUM_TRANSCRIPTS', xlab="UMIs per cell [log10]",  ylab="number of cells", main="Expressed UMIs", xLims=xLims)
    p2=plotHistWithlog10Axis(df, var='singlet_num_inform_umis', xlab="Informative UMIs per cell [log10]",  ylab="number of cells", main="Informative UMIs", xLims=xLims)
    
    maxY=max(1, max (dge$fractionSNPUMIs)*1.1)
    p3=ggplot(dge, aes(x = NUM_TRANSCRIPTS, y = fractionSNPUMIs)) +
    	geom_point(size = 0.25) +
    	labs(x = "num transcripts", y = "fraction of UMIs that are informative") +
    	coord_cartesian(ylim=c(0, maxY)) +
    	ggtitle("Informative UMIs") +
    	theme(axis.text.x = element_text(size = 10), 
    		  axis.text.y = element_text(size = 10),
    		  axis.title = element_text(size = 12),
    		  plot.title = element_text(size = 14)) +
    	theme(panel.background = element_rect(colour = "black")) +
    	scale_x_log10(labels = scales::trans_format('log10', scales::math_format(10^.x)))
    
    
    sortedDonorNames=names (sort (tapply(dge$fractionSNPUMIs, FUN=median, INDEX=dge$donor)))
    dge$donor=factor(dge$donor, levels=sortedDonorNames)
    
    p4=ggplot(dge, aes(x = donor, y = fractionSNPUMIs)) +
    	geom_boxplot() +
    	ggtitle("Informative UMIs per donor") +
    	labs(x = "", y = "fraction of UMIs that are informative") +
    	theme(axis.text.x = element_text(angle = 90, vjust = 0.5, size = 10),
    		  axis.text.y = element_text(size = 10),
    		  axis.title = element_text(size = 12),
    		  plot.title = element_text(size = 14))
    
    # the xlimits on the histograms are slightly cranky but work fine.
    suppressWarnings(gridExtra::grid.arrange(p1, p3, p2, p4, nrow = 2))
    
}

#for each donor, sum all cells expression into a single "meta cell".
generateMetaCells<-function (cellDonorMap, dgeFile, outMetaCellFile, selectedCellsForMetaCellFile=NULL) {

    if (!is.null(selectedCellsForMetaCellFile)) {
        z=read.table(selectedCellsForMetaCellFile, header=F, stringsAsFactors=F)$V1
        z=intersect(z, cellDonorMap$cell)
        cellDonorMap=cellDonorMap[match(z, cellDonorMap$cell),]
    }
    #donor=donors[1]
    makeMetaCell<-function (donor, cellDonorMap, a) {
        cells=cellDonorMap[cellDonorMap$bestSample==donor,]$cell
        idx=match(cells, colnames(a))
        idx=idx[!is.na(idx)]
        x=a[,idx, with=F]
        expression=rowSums(x)
        names(expression)=a$GENE
        return (expression)
    }
    #If there's no data, skip this method.
	if (dim (cellDonorMap)[1]==0)
		return (NULL)
    
    a=DropSeq.utilities::read_dge_txt(dgeFile)
    donors=sort(unique(cellDonorMap$bestSample))
    r=lapply(donors, makeMetaCell, cellDonorMap, a)
    r=do.call(cbind, r)
    colnames(r)=donors
    #put the genes as the first column to look like DGE data.
    result=data.frame(GENE=rownames(r), r, stringsAsFactors = F, check.names = F)
    write.table(result, outMetaCellFile, row.names=F, col.names=T, quote=F, sep="\t")
}

writeSummaryStats<-function (summaryStats, outSummaryStatsFile) {
    #formatting
	summaryStats$cell_equitability=round(summaryStats$cell_equitability, 2)
    summaryStats$diversity=round(summaryStats$diversity,2)
    summaryStats$equitability=round(summaryStats$equitability,2)
    summaryStats$reads_per_umi=round(summaryStats$reads_per_umi,2)
    if (!is.null(outSummaryStatsFile)) write.table(summaryStats, outSummaryStatsFile, row.names=F, col.names = T, quote=F, sep="\t")
}

#' Standard set of analysis for single cell donor assignment.
#' 
#' This generates a QC report with a number of useful plots, along with optional
#' outputs that are useful for downstream analysis.  
#'
#' @param expName The experiment name.  This is used to label plots.
#' @param likelihoodSummaryFile The dropulation single donor likelihood file.  
#' @param doubletLikelihoodFile The dropulation doublet likelihood file.  
#' @param dgeSummaryFile The DGE summary file.  If cleanup steps have been run on the 
#' data, the most processed data should be used at this step to preserve that in the metacell summary.  
#' A DGE summary file is a tab separated file with the follow columns:
#' * CELL_BARCODE: the cell barcode sequence CELL_BARCODE that identifies a single cell uniquely
#' * NUM_TRANSCRIPTS: the total number of UMIs captured by a cell.  This is the sum of expression across all genes. 
#' (optional)
#' @param dgeRawSummaryFile The DGE summary file.  This file should contain the number of UMIs original observed in the 
#' data before any cleanup steps like cellbender. See dgeSummaryFile for file format.  (optional)
#' @param readsPerCellFile The reads per cell file. This file is tab delimited, has no header, and has two columns:
#' 1. The number of reads for a cell barcode
#' 2. The cell barcode identity.  
#' (optional)
#' @param censusFile The census results file. (optional)
#' @param expectedSamplesFile A file containing the expected list of donors in the experiment. The file has no header,
#' and a single donor ID on each line.  
#' @param outFileLikelyDonors Output of which donors are in the experiment based on the Dropulation results.
#' @param outDonorToCellMap A map from each cell barcode to the best donor.  This is restricted to cells
#' that are not doublets and have passed FDR thresholds.  This represents subset of input cells that should
#' be used in downstream analysis that requires donor labels.
#' @param outPDF The output PDF file. (optional)
#' @param outSummaryStatsFile The output summary statistics file. (optional)
#' @param minimumFractionDonor To determine which donors are in the data, what fraction of cells must contain a donor for the 
#' donor to be included in the output.  This controls for a low level of miscalls of donor identity.
#' @param alpha The p-value threshold for doublets.
#' @param rescueDiffuseDoublets [EXPERIMENTAL] Should doublets where the 2nd donor of the pair isn't clear be rescued when possible?  These
#' cells usually have higher amounts of ambient RNA that makes many potential doublet pairs equally likely.  If set to true,
#' attempts to differentiate cells assigned to expected donors from noisy cells to recover a subset of barcodes with marginal scores
#' as singlets.   This method needs a pool where many donors that are evaluated are not expected in the pool (a set of null results).  
#' Without that null result, this option will erroneously rescue cells as singlets - use with caution!
#' @param minNumUMIs Filter cells with fewer than this number of UMIs. (optional)
#' @param dgeFile The input DGE file to generate meta cell output. If cleanup steps have been run on the 
#' data, the most processed data should be used at this step to preserve that in the metacell summary.  This is a tab delimited
#' flat file with each row containing a gene and each column containing a cell barcode.  The first column name is "GENE", followed by 
#' cell barcode identifiers.  (optional)
#' @param outMetaCellFile Sums the expression across cells of each donor to generate a new expression file for donors instead 
#' of cells. (optional)
#' @param selectedCellsForMetaCellFile Limits meta cell expression to a subset of donors.
#' @param outCellBarcodesFile cell barcodes for donors in the experiment (optional)
#' @param anonymizeDonors If set to true, donor IDs are changed to DONOR_1, DONOR_2, etc.  Purely for sharing 
#' visualizations of not-yet-public data.
#' @import grDevices graphics utils stats data.table RColorBrewer  vegan
#' @suggest DropSeq.utilities
#' @export
donorAssignmentQC<-function (expName="", likelihoodSummaryFile, doubletLikelihoodFile, dgeSummaryFile=NULL, dgeRawSummaryFile=NULL,
readsPerCellFile=NULL, censusFile=NULL, expectedSamplesFile, outFileLikelyDonors=NULL, outDonorToCellMap=NULL, outPDF=NULL,
outSummaryStatsFile=NULL, minimumFractionDonor=0.002, alpha=0.05, rescueDiffuseDoublets=F, minNumUMIs=0, dgeFile=NULL,
    outMetaCellFile=NULL, selectedCellsForMetaCellFile=NULL, outCellBarcodesFile=NULL, anonymizeDonors=FALSE) {

    validateFilesExist(likelihoodSummaryFile, doubletLikelihoodFile, dgeRawSummaryFile, dgeSummaryFile, censusFile, expectedSamplesFile)

    summaryStats=data.frame(expName=expName)
    #TODO: maybe not hard code this later?
    doubletPvalueThreshold=0.9

    if (!is.null(outPDF)) pdf(outPDF)

    if (is.null(doubletLikelihoodFile)) {
        # plotCellsByProbabilityNew(likelihoodSummaryFile, cellsToKeep=NULL, fdrThreshold=alpha)
    } else {
		
    	#all filtering/labeling of doublet/singlet status occurs here.    
    	#note: there's a parameter to convert all diffuse doublet to singlets, but it's not used.
    	z=getSingletDoubletDF(likelihoodSummaryFile, doubletLikelihoodFile, expectedSamplesFile=expectedSamplesFile, 
    							   doubletPvalue=doubletPvalueThreshold, bestPairPvalue=doubletPvalueThreshold, 
    							   ignoreDiffuseDoublets=FALSE, fdrThreshold=alpha, anonymizeDonors=anonymizeDonors)
    	
    	#pull out the dataframe and expected samples, which may have been remapped to anon IDs.
    	cellDF=z$cellDF
    	expected_samples=z$expected_samples
    	
    	summaryStats$total_cells=dim(cellDF)[1]
        if (!is.na(minNumUMIs)) {
        	cellDF=cellDF[cellDF$singlet_num_inform_umis>=minNumUMIs,]
        }

    	#this modifies the data frame to set some diffuse doublets to singlet
    	if (rescueDiffuseDoublets) {
    		plotAmbientRescue(cellDF, fdrThreshold=alpha)	
    		plotAmbientRescueDonorLikelihoods(cellDF)
    		z=plotAmbientRescueFDRPlusDonorLike(cellDF, fdrThreshold = alpha)
    		cellDF=plotOptimizedAmbientDonor (cellDF, fdrThreshold=alpha)	
    	}
    	
        doubletStats=evaluateDoubletRateSimple (cellDF, fdrThreshold=alpha)
        pctDS=round(doubletStats[c("fracDoubletAll", "fracDiffuseContaminationDoublets", "fracConfidentDoublets", "fracAllImpossibleDonors", "fracFdrFilteredImpossibleDonors", "fracAllDoubletsFilteredImpossibleDonors")]*100,2)
    	names(pctDS)=c("pct_all_doublets", "pct_diffuse_contam_doublets", "pct_confident_doublets", "pct_impossible_donors", "pct_fdr_impossible_donors", "pct_doublet_filtered_impossible_donors")
        summaryStats=cbind (summaryStats, pctDS)
        
        plotDoubletProbability(df=cellDF, expName = expName, summaryStats=summaryStats, doubletPvalueThreshold=doubletPvalueThreshold)
        
        #add the number of singlets
        singlets=cellDF[cellDF$label_simple=="singlet",]$cell_barcode
        summaryStats$singlets=length(singlets)
		
        plotSummaryStats(summaryStats)
        	
        plotCellsByProbabilityNew(df=cellDF, fdrThreshold=alpha)
		
        #plot some estimates of error rates.
        plotFractionImpossibleAllelesFromDoublets (df=cellDF, expName, fdrThreshold=alpha)
        
        #plot the average likelihood per UMI of singlets, doublets, etc.
        plotAverageLikelihood (df=cellDF)
        
        #plot the average likelihood partitioned by donor assignment.
        # plotAverageLikelihoodPerDonor(df=cellDF, minimumFractionDonor)
    }

    r=plotCommonDonors(df=cellDF, minimumFractionDonor)
    if (!is.null(censusFile)) {
        plotCensusComparison(censusFile, r$summary, expName)
    }
	
    plotCommonDonorsFdrDistribution(df=cellDF, minimumFractionDonor)
    
    donors=r$summary
    cellDonorMap=r$cellDonorMap
    summaryStats$assignable_singlets=dim(cellDonorMap)[1]

    #get cell diversity and add to summary stats
    cellEquitability = getCellEquitability(cellDonorMap)
    summaryStats$cell_equitability=cellEquitability
    
    plotCommonDonorAssignmentsWithUnexpected(donors, expected_samples, expName)
    
    cellsToKeep=cellDonorMap$cell
    zz=calculateMeanUMIsPerDonor(expName, cellDF, dgeSummaryFile, donors, cellsToKeep=cellsToKeep)
    
    donors=zz$donors
    summaryStats=cbind(summaryStats, zz$stats)
    summaryStats$totalUMIs=sum (donors$totalUMIs)
    
    plotRatioUMIsCaptuedToCellSize(dgeRawSummaryFile, cellDF, cellsToKeep=cellDonorMap$cell)
    summaryStats$reads_per_umi=calculateReadsPerUMI(readsPerCellFile, dgeSummaryFile, cellDonorMap)
    if (!is.null(outSummaryStatsFile)) writeSummaryStats(summaryStats, outSummaryStatsFile)
    if (!is.null(outPDF)) dev.off()
    if (!is.null(outFileLikelyDonors)) write.table(donors, outFileLikelyDonors, row.names=F, col.names=T, quote=F, sep="\t")
    if (!is.null(cellDonorMap)) write.table(cellDonorMap, outDonorToCellMap, row.names=F, col.names=T, quote=F, sep="\t")
    if (!is.null(dgeFile) && !is.null(outMetaCellFile)) {
        generateMetaCells(cellDonorMap, dgeFile, outMetaCellFile, selectedCellsForMetaCellFile=selectedCellsForMetaCellFile)
    }
    if (!is.null(outCellBarcodesFile)) {
        write.table(cellDonorMap$cell, outCellBarcodesFile, row.names=F, col.names=F, quote=F)
    }
}


#maps singlet/doublet labels to colors for consistently colored plots
getLabelColors<-function () {
	cols=c('single pass FDR'='green', 'single fail FDR'='blue', 'confident doublet'='red', 'diffuse contamination'='purple')
	return (cols)
}

#' Plot the average penality per UMI for each cell
#' 
#' Color cells by their class.
#'
#' @param df The data frame generated by getSingletDoubletDF
#' @import ggplot2
#' @noRd
plotAverageLikelihood<-function (df) {
	#TO make R CMD CHECK happy.  Blame ggplot2.
	singlet_num_inform_umis=normalizedBestLikelihood=label=value=NULL
	
	df2=data.table::copy(df)
	df2$label=gsub("_", " ", df2$label)
	df2$normalizedBestLikelihood=df2$best_like/df2$singlet_num_inform_umis
	factorOrder=c("single pass FDR", "single fail FDR", "diffuse contamination","confident doublet")
	factorOrder=intersect(factorOrder, df2$label)
	df2$label=factor(df2$label, levels=factorOrder)
	
	p1=ggplot(df2, aes(x = singlet_num_inform_umis, y = normalizedBestLikelihood, color=label)) +
		geom_point(alpha=0.5, size=0.5) +
		scale_x_continuous(trans='log10') +
		xlab("Number of informative UMIs") +
		ylab("Normalized likelihood (likelihood/num inform UMIs)") +
		ggtitle("Donor assignment normalized likelihood") +
		theme_grey(base_size = 10) +
		guides(colour = guide_legend(override.aes = list(size=3))) +
		scale_colour_manual(values=getLabelColors(), name="")
	
	#calculate the average penalty by class.
	avg=tapply(X=df2$normalizedBestLikelihood, INDEX = df2$label, FUN = median)
	
	avg=data.frame(label=names(avg), value=round(as.numeric(avg),4))
	avg$label=factor(avg$label, levels=factorOrder)
	
	p2=ggplot(data=avg, aes(x=label, y=value, fill=label)) + 
		geom_bar(position = 'dodge', stat='identity', alpha=0.5) +
		geom_text(aes(label=value), position=position_dodge(width=0.9), vjust=-0.25, size=4) +
		theme_grey(base_size = 10) +
		theme(legend.position="none") +
		ylab("Median Score") +
		xlab("") +
		scale_fill_manual(values=getLabelColors(), name="")
	
	gridExtra::grid.arrange(p1, p2, nrow = 2, heights=c(0.7, 0.3))
	
}

#' Plot the single cell FDR distribution of each donor
#'
#' @param df The data frame generated by getSingletDoubletDF
#' @inheritParams donorAssignmentQC
#' @noRd
plotAverageLikelihoodPerDonor<-function (df, minimumFractionDonor=0.005) {
	#TO make R CMD CHECK happy.  Blame ggplot2.
	donor=normalizedBestLikelihood=NULL
	
	
	rUnfiltered=sort(table(df$donor), decreasing=T)
	minNum=sum(rUnfiltered)* minimumFractionDonor
	rFiltered=rUnfiltered[rUnfiltered>minNum]
	commonDonors=names (rFiltered)
	
	df2=data.table::copy(df)
	df2$normalizedBestLikelihood=df2$best_like/df2$singlet_num_inform_umis
	subset_data=df2[df2$donor %in% commonDonors,]
	
	# Create the boxplot with -log10 transformation
	p=ggplot(subset_data, aes(x = donor, y = normalizedBestLikelihood)) +
		geom_violin() +
		labs(x = "", y = "Normalized likelihood (likelihood/num inform UMIs)") +
		ggtitle("Normalized likelihood distribution for each common donor") +
		theme(axis.text.x = element_text(angle = 90, vjust = 0.5, size = 10), 
			  axis.text.y = element_text(size = 10),
			  axis.title = element_text(size = 12),
			  plot.title = element_text(size = 14)) +
		theme(panel.background = element_rect(colour = "black"))
	print (p)
}


plotSummaryStats<-function (summaryStats) {
	# quick plot of impossible donors
	# Now combine with the doublet rates.
	par(mfrow=c(2,1))
	stats=c(summaryStats$pct_all_doublets, summaryStats$pct_diffuse_contam_doublets, summaryStats$pct_confident_doublets)
	z=barplot (stats, main="Doublet Rates", names.arg=c("all", "diffuse contamination", "confident"), col="light blue")
	text (y=max(stats)/2, x=z[,1], labels=paste(round(stats,1), "%", sep=""), cex=1.5)        
	stats=c(summaryStats$pct_impossible_donors, summaryStats$pct_fdr_impossible_donors, summaryStats$pct_doublet_filtered_impossible_donors)
	z=barplot (stats, names.arg=c("all", "+fdr filtered", "+doublet filtered"), main="% impossible donors")
	text (y=max(stats)/2, x=z[,1], labels=paste(round(stats,1), "%", sep=""), cex=1.5)        
	par(mfrow=c(1,1))
	
}

getCellEquitability<-function (cellDonorMap) {
	donorCellCounts=table (cellDonorMap$bestSample)
	d=vegan::diversity(donorCellCounts)
	eq=d/log(length(donorCellCounts))
	return (eq)
} 

labelSingletsInDonorList<-function (b, donorListFile) {
	d=read.table(donorListFile, header = F, stringsAsFactors = F)$V1
	lastIdx=which(colnames(b)=="population_average_likelihood")
	cols=c(colnames (b)[1:lastIdx], "in_donorlist", colnames(b) [(lastIdx+1):dim (b)[2]])
	b$in_donorlist=F
	b=b[,match(cols, colnames(b))]
	idx=which(!is.na(match(b$bestSample, d)))
	b[idx,]$in_donorlist=T
	return (b)
}

############################################################################
# Fraction of observed alleles in doublet/singlet call that are impossible.
############################################################################

#' Plots that describe the errors in the doublet donor assignment
#' 
#' Given the doublet analysis, partition cell barcodes into confident singlets,
#' confident doublets, and ambient doublets.
#' For each cell, calculate the fraction of "impossible alleles" - that is, 
#' alleles that are observed that could not have been generated by the donor.
#' For single cells, this is an approximation of the error rate, though perhaps 
#' not the most sensitive one.
#' @param df A data frame of cell level metrics generated by getSingletDoubletDF
#' @param fdrThreshold The desired false discovery rate
#' @param expName An experiment name to use as a title for the plot
#' @import ggplot2
#' @noRd
plotFractionImpossibleAllelesFromDoublets<-function (df, expName, fdrThreshold=0.05) {
	#TO make R CMD CHECK happy.  Blame ggplot2.
	frac_s1_wrong=label=frac_s2_wrong=NULL
	
    x=data.table::copy(df)
    
    #small adjustment for doublet files with faked doublet calls
    x[is.na(x)] = 0
    
    #restrict to cells with a moderate numbers or large of observations (exclude first quantile)
    x2=x[which(x$doublet_num_inform_umis>=quantile (x$doublet_num_inform_umis) [2]) ,]
	
    #restrict singlets to those that pass FDR
    idx=which( (x$label=="single_pass_FDR") | x$label_simple!="singlet")
    x=x[idx,]
    
    df2=data.table::copy(x)
    df2$label=gsub("_", " ", df2$label)
    factorOrder=c("single pass FDR", "single fail FDR", "diffuse contamination","confident doublet")
    factorOrder=intersect(factorOrder, df2$label)
    df2$label=factor(df2$label, levels=factorOrder)
    
    singletErrorRateString=paste(round (median (x[x$label=="single_pass_FDR",]$frac_s1_wrong)*100,2), "%", sep="")
    
    strTitle=paste("Singlets (FDR<=", fdrThreshold, ") + doublets", "\nSinglet Error Rate ", singletErrorRateString, sep="")
    p1 <- ggplot2::ggplot(data=df2, aes(x=frac_s1_wrong, group=label, fill=label)) +
        ggplot2::geom_density(adjust=1.5, alpha=.2) +
        ggplot2::ggtitle (paste(expName, strTitle, sep="\n")) +
        xlab("fraction of alleles that could not be generated by donor one") +
    	scale_fill_manual(values = getLabelColors())

    p2 <- ggplot2::ggplot(data=x, aes(x=frac_s1_wrong, y=frac_s2_wrong, group=label, col=label)) +
        ggplot2::geom_point(alpha=0.2, size=1) +
        ggplot2::ggtitle (paste("Singlet Error Rate", singletErrorRateString)) +
        xlab("fraction donor one allele errors") +
        ylab("fraction donor two allele errors") +
    	scale_fill_manual(values = getLabelColors())

    #gridExtra::grid.arrange(p1, p2, nrow=2)
    gridExtra::grid.arrange(p1, nrow=1)

}


addFracImpossibleAlleles<-function (x) {
    x$sampleTwoMixtureRatio=1-x$sampleOneMixtureRatio
    x$frac_s1_wrong=x$sampleOneWrongAlleleCount/x$num_umi
    x$frac_s2_wrong=x$sampleTwoWrongAlleleCount/x$num_umi
    return (x)

}

#' Evaluate Doublet Rate (Simple)
#' 
#' Emits statistics about the doublet rate, as well as the fraction of cells coming from unexpected donors 
#' are assigned after various filters.
#' @param df A data frame of cell level metrics generated by getSingletDoubletDF
#' @param fdrThreshold The desired false discovery rate
#' @return A dataframe containing summary info about the fraction of doublets and enrichment.
#' @noRd
evaluateDoubletRateSimple<-function (df, fdrThreshold=0.05) {
	fracDoubletAll=length(which(df$label_simple=="doublet"))/dim (df)[1]
	fracConfidentDoublets=length(which(df$label=="confident_doublet"))/dim(df)[1]
	fracDiffuseContaminationDoublets=length(which(df$label=="diffuse_contamination"))/dim(df)[1]
		
	summaryDF=data.frame(fracDoubletAll=fracDoubletAll, fracConfidentDoublets=fracConfidentDoublets,fracDiffuseContaminationDoublets=fracDiffuseContaminationDoublets)
	impossibleStats=calculateFractionImpossibleSingleDonors(df, fdrThreshold)
	summaryDF=cbind(summaryDF, impossibleStats)
	return (summaryDF)
	
}

########################################################
# Consistent method to label the doublet/single status of each cell.
# 
########################################################
#reads in the singlets and doublets, return the median likelihood and best likelihood scores.  Flag cells as doublets based on the pvalue
#bin data by either some set number of qualtiles or a number of fixed bin sizes.
getSingletDoubletDF<-function (likelihoodSummaryFile, doubletLikelihoodFile, expectedSamplesFile=NULL, 
							   doubletPvalue=0.9, bestPairPvalue=0.9, ignoreDiffuseDoublets=FALSE, 
							   fdrThreshold=0.05, anonymizeDonors=FALSE) {
	a=read.table(likelihoodSummaryFile, header=T, stringsAsFactors = F, sep="\t")
	b=read.table(doubletLikelihoodFile, header=T, stringsAsFactors = F, sep="\t")
	
	#add the fraction impossible alleles up-front.
	b=addFracImpossibleAlleles(b)
	
	#note: the same cell barcodes are in both files
	symdiff=union (setdiff(a$cell, b$cell), setdiff(b$cell, a$cell))
	if (length(symdiff)>0) {
		problemCells=paste(head(symdiff), sep="", collapse=",")
		stop ("Something went wrong, donor assignment and doublets have different numbers of cells.  Check cell barcodes [", problemCells, "]")
	}
	both=intersect(b$cell, a$cell)
	a=a[match(both, a$cell),]
	b=b[match(both, b$cell),]
	
	#starting information from the singlet and doublet files	
	df=data.frame(cell_barcode=a$cell, donor=a$bestSample, singlet_num_inform_umis=a$num_umis, 
				  median_like=a$median_likelihood, best_like=a$bestLikelihood, FDR_pvalue=a$FDR_pvalue, 
				  sampleOneMixtureRatio=b$sampleOneMixtureRatio, sampleTwoMixtureRatio=b$sampleOneMixtureRatio,
				  frac_s1_wrong=b$frac_s1_wrong, frac_s2_wrong=b$frac_s2_wrong,
				  stringsAsFactors=F)
	
	#if the best pair pvalue column exists, add it!
	if ("best_pair_pvalue" %in% colnames (b)) {
		idx=match(df$cell_barcode, b$cell)
		df$doublet_pval=b[idx,]$doublet_pval
		df$best_pair_pvalue=b[idx,]$best_pair_pvalue
		df$doublet_num_inform_umis=b[idx,]$num_inform_umis
	}
	
	#add in expected donors if the file exists
	if (!is.null(expectedSamplesFile)) {
		e=read.table(expectedSamplesFile, header=F, stringsAsFactors=F, sep="\t")
		df$expected_donor=df$donor %in% e$V1
		#making this a factor makes life easier later!
		df$expected_donor=factor(df$expected_donor)
	}
	
	#label each cell with it's singlet/doublet status.
	df=labelDoublets(df, doubletPvalue, bestPairPvalue, ignoreDiffuseDoublets)
	
	#label each singlet with if it passes the current FDR.
	#important later when the FDR threshold for the subset of diffuse doublets that are rescued
	df=labelSinglets(df, fdrThreshold = fdrThreshold)
	
	
	#end early if no need to change donor names.
	if (!anonymizeDonors)
		return (list(cellDF=df, expected_samples=e))
		
	
	#Anonymize donors if requested.
	allDonorNames=unique (c(e$V1, df$donor))
	anonDonorNames <- paste("DONOR", as.numeric(factor(allDonorNames)), sep="_")
	df$donor=anonDonorNames[match(df$donor, allDonorNames)]
	e$V1=anonDonorNames[match(e$V1, allDonorNames)]
	return (list(cellDF=df, expected_samples=e))
}

labelSinglets<-function (x, fdrThreshold=0.05) {
	#NOTE: this is the correct way to do the modification without screwing up when the length is 0.
	#this is because we're accessing a vector of values and modifying them instead of rows of a data table.
	
	x$label[x$label_simple=="singlet" & x$FDR_pvalue>fdrThreshold]="single_fail_FDR"
	x$label[x$label_simple=="singlet" & x$FDR_pvalue<=fdrThreshold]="single_pass_FDR"
	return (x)
}

labelDoublets<-function (x, doubletPvalue=0.9, bestPairPvalue=0.9, ignoreDiffuseDoublets=FALSE) {
	x$label="singlet"
	x$label_simple="singlet"
	
	indexConfDoublet <- which(x$doublet_pval>=doubletPvalue & x$best_pair_pvalue>=bestPairPvalue)
	if (length(indexConfDoublet) > 0) {
		x[indexConfDoublet,]$label="confident_doublet"
	}
	
	if (!ignoreDiffuseDoublets) {
		indexDiffuseDoublet <- which(x$doublet_pval>=doubletPvalue & x$best_pair_pvalue<bestPairPvalue)
		if (length(indexDiffuseDoublet) > 0) {
			x[indexDiffuseDoublet,]$label="diffuse_contamination"
		}	
	}
	
	#################
	# SIMPLE LABEL
	# If diffuse doublets are ignored, only count confident doublets as doublets
	# Otherwise, count any doublet as a doublet
	#################
	
	if (ignoreDiffuseDoublets) {
		#only count confident doublet 
		idxSimpleDoublet=which(x$label=="confident_doublet")
	} else {
		#count confident and diffuse doublets
		idxSimpleDoublet=which(x$label=="diffuse_contamination" | x$label=="confident_doublet")
	}
	if (length(idxSimpleDoublet)>0)
		x[idxSimpleDoublet,]$label_simple="doublet"
	
	
	
	return (x)
}

#FDR threshold only applies to doublets.
calculateFractionImpossibleSingleDonors<-function (df, fdrThreshold=0.05) {
	getFracImpossible<-function (df) {
		expectedDonorCount=length(which(df$expected_donor==T))
		impossibleDonorCount=length(which(df$expected_donor==F))
		fracImpossibleDonors=impossibleDonorCount/(impossibleDonorCount+expectedDonorCount)
		return (fracImpossibleDonors)	
	}
	
	#unexpected donors in entire data set.
	fracAllImpossible=length(which(df$expected_donor==F))/dim(df)[1]
	
	#unexpected donors after filtering for FDR
	#a little more complicated now with modified FDR thresholds after rescue
	#The test set includes all doublets that pass FDR + singlets that pass FDR.
	doubletsPlusFDRSinglets=df[which( (df$label_simple=="doublet" & df$FDR_pvalue<fdrThreshold) | df$label=="single_pass_FDR"),]
	fracFdrFilteredImpossible=getFracImpossible(doubletsPlusFDRSinglets)
	
	#filter all doublets out and filter to only singlets that pass FDR
	fdrSinglets=df[which(df$label=="single_pass_FDR"),]
	fracAllDoubletsFilteredImpossible=getFracImpossible(fdrSinglets)
	
	#what's the largest unexpected donor's contribution?
	largestUnexpected=sort (table(df[df$expected_donor==F,]$singletDonor), decreasing=T)[1]
	
	sumDF=data.frame(fracAllImpossibleDonors=fracAllImpossible, fracFdrFilteredImpossibleDonors=fracFdrFilteredImpossible, fracAllDoubletsFilteredImpossibleDonors=fracAllDoubletsFilteredImpossible, stringsAsFactors = F)
	return (sumDF)	
	
	#x=df[df$label=="diffuse_contamination",]
	#plot (x$num_inform_umis, -log10(x$FDR_pvalue), main="Diffuse Doublets", col=factor(x$expected_donor))
}


########################################################
# Diffuse contamination doublet rescue plots/analysis.
########################################################

#' Plot to evaluate ambient rescue
#'
#' @param df The pre-processed data
#' @param fdrThreshold Threshold for filtering false positive results
#' @import scales
#' @noRd
plotAmbientRescue<-function(df, fdrThreshold=0.05) {
	#TO make R CMD CHECK happy.  Blame ggplot2.
	singlet_num_inform_umis=fdr_p=expected_donor=doublet_num_inform_umis=Var1=Freq<-NULL
	
	x=df[df$label=="diffuse_contamination",]
	
	x$fdr_p=-log10(x$FDR_pvalue)
	
	#how many points rescued?
	xx=x[x$FDR_pvalue<fdrThreshold,]
	#summary=as.data.frame.matrix(t(table (xx$expected_donor)))
	summary=data.frame(table (xx$expected_donor))
	
	
	p1=ggplot(x, aes(x=singlet_num_inform_umis, y=fdr_p, color=expected_donor)) +
		geom_point() +
		xlab("Number of singlet informative UMIs") +
		ylab("Donor assignment FDR [-log10]") +
		ggtitle ("Diffuse contamination rescue")	
	
	p2=ggplot(x, aes(x=doublet_num_inform_umis, y=fdr_p, color=expected_donor)) +
		geom_point() +
		xlab("Number of doublet informative UMIs") +
		ylab("Donor assignment FDR [-log10]")
	
	p3=ggplot(data=summary, aes(x=Var1, y=Freq)) +
		geom_bar(stat="identity", fill=scales::hue_pal()(2)) +
		geom_text(aes(label = Freq), position = position_stack(vjust = 0.5), size=5) +
		xlab("Expected Donor") +
		ggtitle ("Cells with FDR < 0.05")	
	
	
	gridExtra::grid.arrange(p1, p2, p3, nrow = 3, heights=c(0.4, 0.4, 0.2))
	
}

#' Plot to evaluate ambient rescue using donor likelihoods.
#'
#' @param df The pre-processed data
#' @import scales
#' @noRd
plotAmbientRescueDonorLikelihoods<-function (df) {
	#TO make R CMD CHECK happy.  Blame ggplot2.
	median_likelihood=donor_likelihood=expected_donor=ratio=Var1=Freq=NULL
	
	x=df[df$label=="diffuse_contamination",]
	
	#don't -log10 the values, how do the plots look?
	xx=data.frame(cell_barcode=x$cell_barcode, FDR_pvalue=x$FDR_pvalue, median_likelihood=x$median_like, 
				  donor_likelihood=x$best_like,expected_donor=x$expected_donor,stringsAsFactors = F)
	
	p1=ggplot(xx, aes(x=median_likelihood, y=donor_likelihood, color=expected_donor)) +
		geom_point() +
		xlab("Population likelihood [log10]") +
		ylab("Donor best likelihood [log10]") +
		ggtitle ("Diffuse contamination rescue")
	
	#could you capture the ratio of donor likelihood to median, and compute donor cells that were some Z scores away?
	xx$ratio=xx$donor_likelihood-xx$median_likelihood
	
	#get the mean and sd of the unexpected donors
	m=mean (xx[xx$expected_donor==F,]$ratio)
	sd=sd (xx[xx$expected_donor==F,]$ratio)
	numSD=3
	threshold=m+(numSD*sd)
	
	p2= ggplot(xx, aes(x = ratio, colour = expected_donor)) +
		geom_density() + 
		xlab("Ratio of donor likelihood to median likelihood") +
		geom_vline(xintercept = threshold, linetype='dotted', color = "black", size=1) +
		ggtitle (paste("Diffuse contamination rescue by median likelihood \nMean + ",numSD, "SD from unexpected donor cells"))		
	
	
	summary=data.frame(table (xx[xx$ratio>threshold,]$expected_donor))
	
	p3=ggplot(data=summary, aes(x=Var1, y=Freq)) +
		geom_bar(stat="identity", fill=scales::hue_pal()(2)) +
		geom_text(aes(label = Freq), position = position_stack(vjust = 0.5), size=5) +
		xlab("Expected Donor") +
		ggtitle (paste("Cells with donor likelihood- median likelihood >= ", round (threshold,3)))	
		
	gridExtra::grid.arrange(p1, p2, p3, nrow = 3, heights=c(0.4, 0.4, 0.2))
	
}

#' Plot to evaluate ambient rescue using both FDR filtering and donor likelihoods.
#'
#' @param df The pre-processed data
#' @param fdrThreshold Threshold for filtering false positive results
#' @import scales
#' @noRd
plotAmbientRescueFDRPlusDonorLike<-function (df, fdrThreshold=0.05) {
	#TO make R CMD CHECK happy.  Blame ggplot2.
	ratio=fdr_p=expected_donor=Var1=Freq=NULL
	
	x=df[df$label=="diffuse_contamination",]
	numCells=dim (x)[1]
	
	xx=data.frame(cell_barcode=x$cell_barcode, FDR_pvalue=x$FDR_pvalue, median_likelihood=x$median_like, 
				  donor_likelihood=x$best_like,expected_donor=x$expected_donor,stringsAsFactors = F)
	
	xx$fdr_p=-log10(xx$FDR_pvalue)
	
	#could you capture the ratio of donor likelihood to median, and compute donor cells that were some Z scores away?
	xx$ratio=xx$donor_likelihood-xx$median_likelihood
	
	#get the mean and sd of the unexpected donors
	m=mean (xx[xx$expected_donor==F,]$ratio)
	sd=sd (xx[xx$expected_donor==F,]$ratio)
	numSD=2
	threshold=m+(numSD*sd)
	
	strTitle=paste("Mean + ",numSD, "SD from unexpected donor cells [", round (threshold,3), "]")
	
	p1=ggplot(xx, aes(x=ratio, y=fdr_p, color=expected_donor)) +
		geom_point() +
		geom_vline(xintercept = threshold, linetype='dotted', color = "black", size=1) +
		geom_hline(yintercept = -log10(fdrThreshold), linetype='dotted', color = "black", size=1) +
		xlab("Ratio of donor likelihood to median likelihood") +
		ylab("Donor assignment FDR [-log10]") +
		ggtitle (paste("Diffuse contamination rescue\n",strTitle, sep=""))
	
	idx=which(xx$ratio>threshold & xx$FDR_pvalue<fdrThreshold)
	summary=data.frame(table (xx[idx,]$expected_donor))
	
	strTitleSuffix=paste("[", length(idx), "] of [", numCells, "] cells rescued [", round (length(idx)/numCells*100, 2), "%]", sep="")
	p2=ggplot(data=summary, aes(x=Var1, y=Freq)) +
		geom_bar(stat="identity", fill=scales::hue_pal()(2)) +
		geom_text(aes(label = Freq), position = position_stack(vjust = 0.5), size=5) +
		xlab("Expected Donor") +
		ggtitle (paste("Combined diffuse doublet rescue\n",strTitleSuffix, sep=""))	
	
	gridExtra::grid.arrange(p1, p2, nrow = 2, heights=c(0.6, 0.4))

	#these diffuse doublets become singlets that pass FDR
	if (length(idx)>0) {
		cellsRescued=xx[idx,]$cell_barcode
		df[match(cellsRescued, df$cell_barcode),]$label="single_pass_FDR"
		df[match(cellsRescued, df$cell_barcode),]$label_simple="singlet"
	}
	
	return (df)
	
}

#' Plot to evaluate ambient rescue using FDR and donor likelihoods,
#' where the final thresholds are optimized to minimize the number
#' of false positives to be under the given FDR threshold.
#'
#' @param df The pre-processed data
#' @param fdrThreshold Threshold for filtering false positive results
#' @import scales
#' @noRd
plotOptimizedAmbientDonor<-function (df, fdrThreshold=0.05) {
	#TO make R CMD CHECK happy.  Blame ggplot2.
	ratio=fdr_p=expected_donor=Var1=Freq=NULL
	
	x=df[df$label=="diffuse_contamination",]
	numCells=dim (x)[1]
	
	#don't -log10 the values, how do the plots look?  Resonable!
	xx=data.frame(cell_barcode=x$cell_barcode, FDR_pvalue=x$FDR_pvalue, median_likelihood=x$median_like, 
				  donor_likelihood=x$best_like,expected_donor=x$expected_donor,stringsAsFactors = F)
	
	xx$fdr_p=-log10(xx$FDR_pvalue)
	
	#could you capture the ratio of donor likelihood to median, and compute donor cells that were some Z scores away?
	xx$ratio=xx$donor_likelihood-xx$median_likelihood
	
	#get the mean and sd of the unexpected donors
	m=mean (xx[xx$expected_donor==F,]$ratio)
	sd=sd (xx[xx$expected_donor==F,]$ratio)
	#this threshold is a starting spot for the optimization
	numSD=2
	threshold=m+(numSD*sd)
	
	###########################################
	# FOR FUN-ISH, optimize the two parameters
	###########################################
	
	scoreThresholds<-function (param, fdrThreshold, xx) {
		#each included expected donor scores a point, each included unexpected donor subtracts 1/fdrThreshold points
		t1=param[1]
		t2=param[2]
		idx=which(xx$ratio>=t1 & xx$fdr_p>=t2)
		#short circuit
		if (length(idx)==0) return (0)
		pos=length(which(xx[idx,]$expected_donor==T))
		neg=length(which(xx[idx,]$expected_donor==F))
		score=pos-(neg*1/fdrThreshold)
		return(score)
	}
	
	opt=optim(par=c(threshold,-log10(fdrThreshold)), fn=scoreThresholds, fdrThreshold=fdrThreshold, xx=xx, control=list(fnscale=-0.01), 
			  method="Nelder-Mead") 
	
	ratioThreshold=opt$par[1]
	fdr_pThreshold=opt$par[2]
	#updated fdr threshold from optimizaton
	fdrThreshold=10^-fdr_pThreshold
	
	idx=which(xx$ratio>=ratioThreshold & xx$fdr_p>=fdr_pThreshold)
	summary=data.frame(table (xx[idx,]$expected_donor))
	
	
	strTitle=paste("ratio [",round(ratioThreshold,3),"] FDR [", round (fdrThreshold,3), "]")
	p1=ggplot(xx, aes(x=ratio, y=fdr_p, color=expected_donor)) +
		geom_point() +
		geom_vline(xintercept = ratioThreshold, linetype='dotted', color = "black", size=1) +
		geom_hline(yintercept = fdr_pThreshold, linetype='dotted', color = "black", size=1) +
		xlab("Ratio of donor likelihood to median likelihood") +
		ylab("Donor assignment FDR [-log10]") +
		ggtitle (paste("Diffuse contamination rescue\nOptimized thresholds", strTitle))
	
	strTitleSuffix=paste("[", length(idx), "] of [", numCells, "] cells rescued [", round (length(idx)/numCells*100, 2), "%]")
	
	p2= ggplot(data=summary, aes(x=Var1, y=Freq)) +
		geom_bar(stat="identity", fill=scales::hue_pal()(2)) +
		geom_text(aes(label = Freq), position = position_stack(vjust = 0.5), size=5) +
		xlab("Expected Donor") +
		ggtitle (paste("Optimized Threshold Combined diffuse doublet rescue\n",strTitleSuffix))	
	
	gridExtra::grid.arrange(p1, p2, nrow = 2, heights=c(0.6, 0.4))
	
	#these diffuse doublets become singlets that pass FDR
	if (length(idx)>0) {
		cellsRescued=xx[idx,]$cell_barcode
		df[match(cellsRescued, df$cell_barcode),]$label="single_pass_FDR"
		df[match(cellsRescued, df$cell_barcode),]$label_simple="singlet"
	}
	
	return (df)
}

# MIT License
#
# Copyright 2024 Broad Institute
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

#' Test if string ends with given suffix
#'
#' @param theString string to be tested
#' @param theExt suffix to be tested for
#' @return TRUE if theString ends with theExt
#' @export
strEndsWith<-function(theString,theExt) {
  return(substring(theString,1+nchar(theString)-nchar(theExt))==theExt)
}

#' Test if string starts with given prefix
#'
#' @param theString string to be tested
#' @param thePrefix prefix to be tested for
#' @return TRUE if theString starts with thePrefix
#' @export
strStartsWith = function(theString, thePrefix) {
  return(substr(theString, 1, nchar(thePrefix)) == thePrefix)
}

#' Remove a suffix from a string
#'
#' It is an error if the string does not end with the suffix.
#'
#' @param str the string to be truncated
#' @param suffix the string to be checked for and removed
#' @return the string with suffix removed
#' @export
removeSuffix = function(str, suffix) {
  if (!strEndsWith(str, suffix)) {
    stop(paste0("'", str, "' does not end with '", suffix, "'"))
  }
  return(substr(str, 1, nchar(str) - nchar(suffix)))
}

#' Remove a suffix from a string, if it is present.
#'
#' If the string does not end with the suffix, it is not truncated.
#'
#' @param str the string to be truncated
#' @param suffix the string to be checked for and removed
#' @return the string with suffix removed, if present, otherwise the original string
#' @export
maybeRemoveSuffix = function(str, suffix) {
  if (!strEndsWith(str, suffix)) {
    return(str)
  } else {
    return(substr(str, 1, nchar(str) - nchar(suffix)))
  }
}

#' Remove a suffix from a file and append a new one.
#' @param str String on which to operate.
#' @param oldSuffix suffix to be replaced.
#' @param newSuffix the replacement.
#' @return str with oldSuffix replaced by newSuffix
#' @export
replaceSuffix = function(str, oldSuffix, newSuffix) {
  return(paste0(removeSuffix(str, oldSuffix), newSuffix))
}

#' Split string into pieces of the given length
#' @param s String to be split
#' @param len desired length
#' @return vector of pieces.  Note that last piece may not be full length.
#' @export
splitStringByLength<-function(s, len) {
  if (nchar(s) <= len) return(s)
  starts <- seq(1, nchar(s), len)
  ends <- seq(len, nchar(s), len)
  if (length(ends) < length(starts)) {
    ends <- c(ends, nchar(s))
  }
  return(substring(s, starts, ends))
}

#!/usr/bin/env bash
# MIT License
#
# Copyright 2018 Broad Institute
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

tmpdir=
outdir=`pwd`
genomedir=
reference=
echo_prefix=
dropseq_root=$(dirname $0)
star_executable=STAR
keep_intermediates=0
progname=`basename $0`

function usage () {
    cat >&2 <<EOF
USAGE: $progname [options] <unmapped-queryname-sorted.bam>
Perform Drop-seq tagging, trimming and alignment

-g <genomedir>      : Directory of STAR genome directory.  Required.
-r <referencefasta> : Reference fasta of the Drop-seq reference metadata bundle.  Required.
-d <dropseq_root>   : Directory containing Drop-seq executables.  Default: directory containing this script.
-o <outputdir>      : Where to write output bam.  Default: current directory.
-t <tmpdir>         : Where to write temporary files.  Default: a new subdirectory in $TMPDIR.
-s <STAR_path>      : Full path of STAR.  Default: STAR is found via PATH environment variable.
-e                  : Echo commands instead of executing them.
-k                  : Keep intermediate files
EOF
}

function error_exit() {
    echo "ERROR: $1
    " >&2
    usage
    exit 1
}

function check_set() {
    value=$1
    name=$2
    flag=$3

    if [[ -z "$value" ]]
    then error_exit "$name has not been specified.  $flag flag is required"
    fi
}

set -e
# Fail if any of the commands in a pipeline fails
set -o pipefail

while getopts ":d:t:o:g:r:es:k" options; do
  case $options in
    d ) dropseq_root=$OPTARG;;
    t ) tmpdir=$OPTARG;;
    o ) outdir=$OPTARG;;
    g ) genomedir=$OPTARG;;
    r ) reference=$OPTARG;;
    s ) star_executable=$OPTARG;;
    e ) echo_prefix="echo";;
    k ) keep_intermediates=1;;
    h ) usage
          exit 1;;
    \? ) usage
         exit 1;;
    * ) usage
          exit 1;;
  esac
done
shift $(($OPTIND - 1))

check_set "$dropseq_root" "Drop-seq root" "-d"
check_set "$genomedir" "Genome directory" "-g"
check_set "$reference" "Reference fasta"  "-r"

if (( $# != 1 ))
then error_exit "Incorrect number of arguments"
fi

if [[ -z "$tmpdir" ]]
then tmpdir=`mktemp -d`
     echo "Using temporary directory $tmpdir"
fi

if [[ "$star_executable" != "STAR" ]]
then if [[ ! ( -x $star_executable && -f $star_executable ) ]]
     then error_exit "STAR executable $star_executable passed via -s does not exist or is not executable"
     fi
elif which STAR > /dev/null
then echo > /dev/null
else error_exit "STAR executable must be on the path"
fi

reference_basename=$(basename $(basename $reference .gz) .fasta)
gene_intervals=$(dirname $reference)/$reference_basename.genes.intervals
exon_intervals=$(dirname $reference)/$reference_basename.exon.intervals
refflat=$(dirname $reference)/$reference_basename.refFlat
picard_jar=${dropseq_root}/3rdParty/picard/picard.jar

unmapped_bam=$1
tagged_unmapped_bam=${tmpdir}/unaligned_mc_tagged_polyA_filtered.bam
aligned_sam=${tmpdir}/star.Aligned.out.sam
aligned_sorted_bam=${tmpdir}/aligned.sorted.bam
files_to_delete=


# Stage 4
merge_bam=""
tag_with_gene_exon=""

# Stage 1: pre-alignment tag and trim

# cellular tag
$echo_prefix ${dropseq_root}/TagBamWithReadSequenceExtended SUMMARY=${outdir}/unaligned_tagged_Cellular.bam_summary.txt \
  BASE_RANGE=1-12 BASE_QUALITY=10 BARCODED_READ=1 DISCARD_READ=false TAG_NAME=XC NUM_BASES_BELOW_QUALITY=1 \
  INPUT=${unmapped_bam} OUTPUT=$tmpdir/unaligned_tagged_Cell.bam
files_to_delete="$files_to_delete $tmpdir/unaligned_tagged_Cell.bam"

# molecular tag
$echo_prefix ${dropseq_root}/TagBamWithReadSequenceExtended SUMMARY=${outdir}/unaligned_tagged_Molecular.bam_summary.txt \
  BASE_RANGE=13-20 BASE_QUALITY=10 BARCODED_READ=1 DISCARD_READ=true TAG_NAME=XM NUM_BASES_BELOW_QUALITY=1 \
  INPUT=$tmpdir/unaligned_tagged_Cell.bam OUTPUT=$tmpdir/unaligned_tagged_CellMolecular.bam
files_to_delete="$files_to_delete $tmpdir/unaligned_tagged_CellMolecular.bam"

# quality filter
$echo_prefix ${dropseq_root}/FilterBam TAG_REJECT=XQ INPUT=$tmpdir/unaligned_tagged_CellMolecular.bam \
  OUTPUT=$tmpdir/unaligned_tagged_filtered.bam
files_to_delete="$files_to_delete $tmpdir/unaligned_tagged_filtered.bam"

# read trimming
$echo_prefix ${dropseq_root}/TrimStartingSequence OUTPUT_SUMMARY=${outdir}/adapter_trimming_report.txt \
  SEQUENCE=AAGCAGTGGTATCAACGCAGAGTGAATGGG MISMATCHES=0 NUM_BASES=5 INPUT=$tmpdir/unaligned_tagged_filtered.bam \
  OUTPUT=$tmpdir/unaligned_tagged_trimmed_smart.bam
files_to_delete="$files_to_delete $tmpdir/unaligned_tagged_trimmed_smart.bam"

$echo_prefix ${dropseq_root}/PolyATrimmer OUTPUT=${tagged_unmapped_bam} OUTPUT_SUMMARY=${outdir}/polyA_trimming_report.txt \
  MISMATCHES=0 NUM_BASES=6 NEW=true INPUT=$tmpdir/unaligned_tagged_trimmed_smart.bam
files_to_delete="$files_to_delete ${tagged_unmapped_bam}"


# Stage 2: alignment
$echo_prefix java -Xmx500m -jar ${picard_jar} SamToFastq INPUT=${tmpdir}/unaligned_mc_tagged_polyA_filtered.bam \
  FASTQ=$tmpdir/unaligned_mc_tagged_polyA_filtered.fastq
files_to_delete="$files_to_delete $tmpdir/unaligned_mc_tagged_polyA_filtered.fastq"

$echo_prefix $star_executable --genomeDir ${genomedir} --outFileNamePrefix ${tmpdir}/star. \
  --readFilesIn $tmpdir/unaligned_mc_tagged_polyA_filtered.fastq
files_to_delete="$files_to_delete ${aligned_sam}"

# Stage 3: sort aligned reads (STAR does not necessarily emit reads in the same order as the input)
$echo_prefix java -Dsamjdk.buffer_size=131072 -XX:GCTimeLimit=50 -XX:GCHeapFreeLimit=10 -Xmx4000m -jar ${picard_jar} \
  SortSam INPUT=${aligned_sam} OUTPUT=${aligned_sorted_bam} SORT_ORDER=queryname TMP_DIR=${tmpdir}
files_to_delete="$files_to_delete ${aligned_sorted_bam}"

# Stage 4: merge and tag aligned reads
$echo_prefix java -Xmx4000m -jar ${picard_jar} MergeBamAlignment REFERENCE_SEQUENCE=${reference} UNMAPPED_BAM=${tagged_unmapped_bam} \
  ALIGNED_BAM=${aligned_sorted_bam} INCLUDE_SECONDARY_ALIGNMENTS=false PAIRED_RUN=false CLIP_ADAPTERS=false \
  TMP_DIR=${tmpdir} OUTPUT=$tmpdir/merged.bam
files_to_delete="$files_to_delete $tmpdir/merged.bam"

$echo_prefix ${dropseq_root}/TagReadWithInterval I=$tmpdir/merged.bam O=$tmpdir/gene_tagged.bam TMP_DIR=${tmpdir} \
  INTERVALS=${gene_intervals} TAG=XG
files_to_delete="$files_to_delete $tmpdir/gene_tagged.bam"

$echo_prefix ${dropseq_root}/TagReadWithGeneFunction O=${tmpdir}/function_tagged.bam ANNOTATIONS_FILE=${refflat} \
  INPUT=$tmpdir/gene_tagged.bam
files_to_delete="$files_to_delete $tmpdir/function_tagged.bam"

# Stage 5: bead repair
$echo_prefix ${dropseq_root}/DetectBeadSubstitutionErrors INPUT=${tmpdir}/function_tagged.bam OUTPUT=${tmpdir}/substitution_repaired.bam \
  TMP_DIR=$tmpdir MIN_UMIS_PER_CELL=20 OUTPUT_REPORT=${outdir}/substitution_error_report.txt
files_to_delete="$files_to_delete ${tmpdir}/substitution_repaired.bam"

$echo_prefix ${dropseq_root}/DetectBeadSynthesisErrors INPUT=${tmpdir}/substitution_repaired.bam MIN_UMIS_PER_CELL=20 \
  OUTPUT_STATS=${outdir}/synthesis_error_stats.txt SUMMARY=${outdir}/synthesis_error_summary.txt \
  REPORT=${outdir}/synthesis_error_report.txt CREATE_INDEX=true TMP_DIR=$tmpdir OUTPUT=$outdir/final.bam

if (( $keep_intermediates == 0 ))
then $echo_prefix rm $files_to_delete
fi

echo "Completed successfully."

#!/bin/sh

# MIT License
#
# Copyright 2023 Broad Institute
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.


progname=$(basename "$0")

main_class=org.broadinstitute.dropseqrna.cmdline.DropSeqMain


usage () {
    cat >&2 <<EOF
USAGE: $progname -t <template-file> -c <classpath> -d <output-directory> -m <main-class> [main-class-args...]
Create wrapper scripts for Java command-line programs.

-t <template-file>    : File to be copied to make the wrapper.  Required.
-c <classpath>        : Classpath for running the CLP lister.  Required.
-d <output-directory> : Where to write the wrappers.  Required.
-m <main-class>       : Class to invoke to list CLPs.  Default: '$main_class'.
-h                    : Print usage and exit.
[main-class-args]     : Argument to pass to main class.
EOF
}

error_exit() {
    echo "ERROR: $1
    " >&2
    usage
    exit 1
}

check_set() {
    value=$1
    name=$2
    flag=$3

    if [ -z "$value" ]
    then error_exit "$name has not been specified.  $flag flag is required"
    fi
}


set -e

# Unset all variables to be set based on parameters that have not been
# initialized previously in this script 'in order to ensure they're passed on
# command line rather than inherited from somewhere'.
# See https://github.com/broadinstitute/Drop-seq/pull/412#discussion_r1569231368
# for the corresponding discussion.
unset \
  template \
  classpath \
  outdir

while getopts ':t:c:d:m:h' options; do
  case $options in
    t ) template=$OPTARG;;
    c ) classpath=$OPTARG;;
    d ) outdir=$OPTARG;;
    m ) main_class=$OPTARG;;
    h ) usage
          exit 0;;
    \? ) usage
         exit 1;;
    * ) usage
          exit 1;;
  esac
done
shift $((OPTIND - 1))

check_set "$outdir" 'output directory' '-d'
check_set "$template" 'wrapper script template' '-t'
check_set "$classpath" 'classpath' '-c'


main_class_args="$*"
clp_names=$(java -cp "$classpath" "$main_class" "$main_class_args" || echo > /dev/null)


mkdir -p "$outdir"

if [ -z "$clp_names" ]
then echo 'There was a problem getting CLP names.'
     exit 1
fi
for clp_name in $clp_names
do cp -p "$template" "$outdir/$clp_name"
done


echo 'Created wrapper scripts.'

#!/bin/bash
# MIT License
#
# Copyright 2017 Broad Institute
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.


xmx=4g

progname=__PROGNAME__
thisdir=`dirname ${BASH_SOURCE[0]}`
if [ -f $thisdir/loadDotKits.sh ]
then source $thisdir/loadDotKits.sh
fi

jar_deploy_dir=$thisdir/jar
verbose=0

USAGE=$(cat << EOF
USAGE: $0 [-m <jvm_heap_size>] [-v] program args...
       -m <jvm_heap_size> (default $xmx)
       -v echo final command line before executing

Program options:
EOF
)

function usage () {
    echo "$USAGE" >&2
    java -Xmx${xmx} -jar $jar_deploy_dir/dropseq.jar $progname -h
}

set -e

while getopts ":m:vh" options; do
  case $options in
    m ) xmx=$OPTARG;;
    v ) verbose=1;;
    h ) usage
          exit 1;;
    \? ) break;; # exit option parsing at unrecognized option, so new-style Picard CLP args will survive.
    * ) usage
          exit 1;;

  esac
done
shift $(($OPTIND - 1))

broad_tmpdir_root=/broad/hptmp
if [ -z "$TMPDIR" -a -d $broad_tmpdir_root ]
then export TMPDIR=$broad_tmpdir_root/$USER
fi

if (( $verbose ))
then set -x
fi

java -Xmx${xmx} -XX:+UseParallelOldGC -XX:ParallelGCThreads=1 -XX:GCTimeLimit=50 -XX:GCHeapFreeLimit=10 -XX:+HeapDumpOnOutOfMemoryError -Djava.io.tmpdir=$TMPDIR -jar $jar_deploy_dir/dropseq.jar $progname $*

#!/usr/bin/env bash
# MIT License
#
# Copyright 2018 Broad Institute
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

progname=`basename $0`
function usage () {
    cat >&2 <<EOF
USAGE: $progname [options]
Create Drop-seq reference metadata bundle

-n <name>           : Name for reference metadata set to be created.  Required.
-r <referencefasta> : Reference fasta of the Drop-seq reference metadata bundle.  Required.
-s <species>        : Species.  Required.
-g <gtf>            : Gene annotation file.  Required.
-f <filtered-gene-biotype>: Annotations with the given gene_biotype will be filtered. Multiple values may be
                      specified by using this argument more than once, and/or by providing a comma-separated list.
                      Use ValidateReference command to see the gene_biotypes in your GTF in order to decide what to
                      exclude.  Default: not gene biotypes are filtered.
-d <dropseq_root>   : Directory containing Drop-seq executables.  Default: directory containing this script.
-o <outputdir>      : Where to write output bam.  Default: current directory.
-t <tmpdir>         : Where to write temporary files.  Default: Value of $$TMPDIR environment variable.
-a <STAR_path>      : Full path of STAR.  Default: STAR is found via PATH environment variable.
-b <bgzip_path>     : Full path of bgzip: Default: bgzip is found via PATH environment variable.
-i <samtools_path>  : Full path of samtools.  Default: samtools is found via PATH environment variable.
-v                  : verbose
-e                  : merely echo commands instead of executing
EOF
}

function error_exit() {
    echo "ERROR: $@
    " >&2
    exit 1
}


unset reference_name
unset reference_fasta
unset species
unset gtf
filtered_gene_biotypes=
unset dropseq_root
outdir=.
tmpdir=$TMPDIR
star_executable=`which STAR 2> /dev/null`
samtools_executable=`which samtools 2> /dev/null`
bgzip_executable=`which bgzip 2> /dev/null`
verbose=0
ECHO=

set -e
# Fail if any of the commands in a pipeline fails
set -o pipefail



while getopts ":n:r:s:g:f:d:o:t:a:i:b:ev" options; do
  case $options in
    n ) reference_name=$OPTARG;;
    r ) reference_fasta=$OPTARG;;
    s ) species=$OPTARG;;
    g ) gtf=$OPTARG;;
    f ) filtered_gene_biotypes="$filtered_gene_biotypes G=$OPTARG";;
    d ) dropseq_root=$OPTARG;;
    o ) outdir=$OPTARG;;
    t ) tmpdir=$OPTARG;;
    a ) star_executable=$OPTARG;;
    i ) samtools_executable=$OPTARG;;
    b ) bgzip_executable=$OPTARG;;
    e ) ECHO=echo;;
    v ) verbose=1;;
    h ) usage
          exit 1;;
    \? ) usage
         exit 1;;
    * ) usage
          exit 1;;
  esac
done
shift $(($OPTIND - 1))

: ${reference_name:?"ERROR: -n is required"}
: ${reference_fasta:?"ERROR: -r is required"}
: ${species:?"ERROR: -s is required"}
: ${gtf:?"ERROR: -g is required"}
: ${dropseq_root:?"ERROR: -d is required"}
: ${star_executable:?"ERROR: -s is required if STAR is not on PATH"}
: ${samtools_executable:?"ERROR: -i is required if samtools is not on PATH"}
: ${bgzip_executable:?"ERROR: -b is required if bgzip is not on PATH"}

function check_invoke() {
    if (( $verbose ))
    then echo $@
    fi
    if $ECHO $@
    then :
    else error_exit "non-zero exit status " $? " executing $@"
    fi
}

function invoke_picard() {
    check_invoke java -jar $dropseq_root/3rdParty/picard/picard.jar $@
}

function invoke_dropseq() {
    dropseq_program=$1
    shift
    check_invoke $dropseq_root/$dropseq_program $@
}

output_fasta=$outdir/$reference_name.fasta
sequence_dictionary=$outdir/$reference_name.dict
output_gtf=$outdir/$reference_name.gtf
reduced_gtf=$outdir/$reference_name.reduced.gtf

invoke_picard NormalizeFasta INPUT=$reference_fasta OUTPUT=$output_fasta
if [ -e $sequence_dictionary ]
then $ECHO rm $sequence_dictionary
fi
invoke_picard CreateSequenceDictionary REFERENCE=$output_fasta OUTPUT=$sequence_dictionary SPECIES=$species
invoke_dropseq FilterGtf GTF=$gtf SEQUENCE_DICTIONARY=$sequence_dictionary OUTPUT=$output_gtf $filtered_gene_biotypes
invoke_dropseq ConvertToRefFlat ANNOTATIONS_FILE=$output_gtf SEQUENCE_DICTIONARY=$sequence_dictionary OUTPUT=$outdir/$reference_name.refFlat
invoke_dropseq ReduceGtf GTF=$output_gtf SEQUENCE_DICTIONARY=$sequence_dictionary OUTPUT=$reduced_gtf
invoke_dropseq CreateIntervalsFiles SEQUENCE_DICTIONARY=$sequence_dictionary REDUCED_GTF=$reduced_gtf PREFIX=$reference_name \
           OUTPUT=$outdir
$ECHO mkdir -p $outdir/STAR
check_invoke $star_executable --runMode genomeGenerate --genomeDir $outdir/STAR --genomeFastaFiles $output_fasta \
           --sjdbGTFfile $output_gtf --sjdbOverhang 100
check_invoke $bgzip_executable $output_fasta
check_invoke $samtools_executable faidx $output_fasta.gz

echo "Reference metadata created sucessfully"

#!/bin/sh

# MIT License
#
# Copyright 2023 Broad Institute
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.


progname=$(basename "$0")
thisdir=$(dirname "$0")

xmx=4g
verbose=0


usage () {
    cat >&2 <<EOF
USAGE: $progname [-m <jvm_heap_size>] [-v] program args...

-m <jvm_heap_size> : Heap size to allocate for the JVM.  Default: $xmx.
-v                 : Echo final command line before executing.
-h                 : Print usage and exit.

Program options:
EOF
    "$thisdir"/bin/dropseq "$progname" -h
}


set -e

# Note: All variables to be set based on parameters have been initialized
# previously in this script.
# If that wasn't the case, all the uninitialized ones should be unset here 'in
# order to ensure they're passed on command line rather than inherited from
# somewhere'.
# See https://github.com/broadinstitute/Drop-seq/pull/412#discussion_r1569231368
# for the corresponding discussion.

while getopts ':m:vh' options; do
  case $options in
    m ) xmx=$OPTARG;;
    v ) verbose=1;;
    h ) usage
          exit 0;;
    \? ) break;; # exit option parsing at unrecognized option, so new-style Picard CLP args will survive.
    * ) usage
          exit 1;;

  esac
done
shift $((OPTIND - 1))


broad_tmpdir_root=/broad/hptmp
if [ -z "$TMPDIR" ] && [ -d $broad_tmpdir_root ]
then export TMPDIR="$broad_tmpdir_root/$USER"
fi

JAVA_OPTS="$JAVA_OPTS -Xmx$xmx"
if [ -n "$TMPDIR" ]
then JAVA_OPTS="$JAVA_OPTS -Djava.io.tmpdir=$TMPDIR"
fi

if [ "$verbose" -eq 1 ]
then set -x
fi


JAVA_OPTS="$JAVA_OPTS" "$thisdir"/bin/dropseq "$progname" "$@"

#!/bin/sh

# MIT License
#
# Copyright 2018 Broad Institute
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.


. "$(dirname "$0")"/defs.sh

progname=$(basename "$0")

outdir=$(pwd)
star_executable=$(which STAR 2> /dev/null)
ncores=1
bead_repair=0
keep_intermediates=0


usage () {
    cat >&2 <<EOF
USAGE: $progname [options] <unmapped-queryname-sorted.bam>
Perform Drop-seq tagging, trimming and alignment.

-g <genomedir>      : Directory of STAR genome directory.  Required.
-r <referencefasta> : Reference fasta of the Drop-seq reference metadata bundle.  Required.
-o <outputdir>      : Where to write output bam.  Default: '$outdir'.
-s <STAR_path>      : Full path of STAR.  Default: '$star_executable'.
-n <ncores>         : Number of cores to run.  Default: $ncores.
-b                  : Do bead repair.  Not needed for 10X libraries, but recommended for Drop-seq chemistry.
-e                  : Echo commands instead of executing them.
-k                  : Keep intermediate files.
-v                  : Run in verbose mode.
-h                  : Print usage and exit.
EOF
}


set -e

# Unset all variables to be set based on parameters that have not been
# initialized previously in this script (or a script sourced above) 'in order
# to ensure they're passed on command line rather than inherited from
# somewhere'.
# See https://github.com/broadinstitute/Drop-seq/pull/412#discussion_r1569231368
# for the corresponding discussion.
unset \
  genomedir \
  reference

while getopts ':g:r:o:s:n:bekvh' options; do
  case $options in
    g ) genomedir=$OPTARG;;
    r ) reference=$OPTARG;;
    o ) outdir=$OPTARG;;
    s ) star_executable=$OPTARG;;
    n ) ncores=$OPTARG;;
    b ) bead_repair=1;;
    e ) ECHO='echo';;
    k ) keep_intermediates=1;;
    v ) verbose=1;;
    h ) usage
          exit 0;;
    \? ) usage
         exit 1;;
    * ) usage
          exit 1;;
  esac
done
shift $((OPTIND - 1))

check_set "$genomedir" 'Genome directory' '-g'
check_set "$reference" 'Reference fasta'  '-r'

check_TMPDIR

TMPDIR=$(mktemp -d)
echo "Writing temporary files to $TMPDIR" 

if [ "$#" -ne 1 ]
then error_exit 'Incorrect number of arguments'
fi

if [ "$star_executable" != 'STAR' ]
then if [ ! -x "$star_executable" ] || [ ! -f "$star_executable" ]
     then error_exit "STAR executable $star_executable passed via -s does not exist or is not executable"
     fi
elif which STAR > /dev/null
then echo > /dev/null
else error_exit 'STAR executable must be on the path'
fi

reference_basename=$(basename "$(basename "$reference" .gz)" .fasta)
gene_intervals=$(dirname "$reference")/"$reference_basename".genes.intervals
refflat=$(dirname "$reference")/"$reference_basename".refFlat

unmapped_bam=$1
tagged_unmapped_bam=$TMPDIR/unaligned_mc_tagged_polyA_filtered.bam
aligned_sam=$TMPDIR/star.Aligned.out.sam
aligned_sorted_bam=$TMPDIR/aligned.sorted.bam


# Setup intermediate file cleanup

set --
# shellcheck disable=SC2142 # This is just for readability.
alias mark_file_as_intermediate='set -- "$@" '
# shellcheck disable=SC2317 # This function is called via a trap (see below).
cleanup_intermediates() {
    exit_code=$?
    if [ "$keep_intermediates" -eq 1 ]
    then
      [ "$verbose" -ne 1 ] || echo 'Keeping intermediate files.'
      exit "$exit_code"
    fi
    if [ "$exit_code" -ne 0 ]
    then
      [ "$verbose" -ne 1 ] || echo 'An error occurred...keeping intermediate files.'
      exit "$exit_code"
    fi
    [ "$verbose" -ne 1 ] || echo 'Finished successfully...removing intermediate files...'
    for intermediate_file do
      [ "$verbose" -ne 1 ] || echo "...removing intermediate file '$intermediate_file'."
      rm -- "$intermediate_file"
    done
}
trap 'cleanup_intermediates "$@"' EXIT


# Stage 1: pre-alignment tag and trim

# cellular tag
invoke_dropseq TagBamWithReadSequenceExtended SUMMARY="$outdir"/unaligned_tagged_Cellular.bam_summary.txt \
  BASE_RANGE=1-12 BASE_QUALITY=10 BARCODED_READ=1 DISCARD_READ=false TAG_NAME=XC NUM_BASES_BELOW_QUALITY=1 \
  INPUT="$unmapped_bam" OUTPUT="$TMPDIR"/unaligned_tagged_Cell.bam
mark_file_as_intermediate "$TMPDIR"/unaligned_tagged_Cell.bam

# molecular tag
invoke_dropseq TagBamWithReadSequenceExtended SUMMARY="$outdir"/unaligned_tagged_Molecular.bam_summary.txt \
  BASE_RANGE=13-20 BASE_QUALITY=10 BARCODED_READ=1 DISCARD_READ=true TAG_NAME=XM NUM_BASES_BELOW_QUALITY=1 \
  INPUT="$TMPDIR"/unaligned_tagged_Cell.bam OUTPUT="$TMPDIR"/unaligned_tagged_CellMolecular.bam
mark_file_as_intermediate "$TMPDIR"/unaligned_tagged_CellMolecular.bam

# quality filter
invoke_dropseq FilterBam TAG_REJECT=XQ INPUT="$TMPDIR"/unaligned_tagged_CellMolecular.bam \
  OUTPUT="$TMPDIR"/unaligned_tagged_filtered.bam
mark_file_as_intermediate "$TMPDIR"/unaligned_tagged_filtered.bam

# read trimming
invoke_dropseq TrimStartingSequence OUTPUT_SUMMARY="$outdir"/adapter_trimming_report.txt \
  SEQUENCE=AAGCAGTGGTATCAACGCAGAGTGAATGGG MISMATCHES=0 NUM_BASES=5 INPUT="$TMPDIR"/unaligned_tagged_filtered.bam \
  OUTPUT="$TMPDIR"/unaligned_tagged_trimmed_smart.bam
mark_file_as_intermediate "$TMPDIR"/unaligned_tagged_trimmed_smart.bam

invoke_dropseq PolyATrimmer OUTPUT="$tagged_unmapped_bam" OUTPUT_SUMMARY="$outdir"/polyA_trimming_report.txt \
  MISMATCHES=0 NUM_BASES=6 NEW=true INPUT="$TMPDIR"/unaligned_tagged_trimmed_smart.bam
mark_file_as_intermediate "$tagged_unmapped_bam"


# Stage 2: alignment

invoke_picard SamToFastq INPUT="$TMPDIR"/unaligned_mc_tagged_polyA_filtered.bam \
  FASTQ="$TMPDIR"/unaligned_mc_tagged_polyA_filtered.fastq
mark_file_as_intermediate "$TMPDIR"/unaligned_mc_tagged_polyA_filtered.fastq

$ECHO "$star_executable" --genomeDir "$genomedir" --outFileNamePrefix "$TMPDIR"/star. \
  --readFilesIn "$TMPDIR"/unaligned_mc_tagged_polyA_filtered.fastq --runThreadN "$ncores"
mark_file_as_intermediate "$aligned_sam"

$ECHO mv "$TMPDIR"/star.Log.final.out "$outdir"


# Stage 3: sort aligned reads (STAR does not necessarily emit reads in the same order as the input)

invoke_picard \
  SortSam INPUT="$aligned_sam" OUTPUT="$aligned_sorted_bam" SORT_ORDER=queryname TMP_DIR="$TMPDIR"
mark_file_as_intermediate "$aligned_sorted_bam"


# Stage 4: merge and tag aligned reads

invoke_picard MergeBamAlignment REFERENCE_SEQUENCE="$reference" UNMAPPED_BAM="$tagged_unmapped_bam" \
  ALIGNED_BAM="$aligned_sorted_bam" INCLUDE_SECONDARY_ALIGNMENTS=false PAIRED_RUN=false CLIP_ADAPTERS=false \
  TMP_DIR="$TMPDIR" OUTPUT="$TMPDIR"/merged.bam
mark_file_as_intermediate "$TMPDIR"/merged.bam

invoke_dropseq TagReadWithInterval I="$TMPDIR"/merged.bam O="$TMPDIR"/gene_tagged.bam TMP_DIR="$TMPDIR" \
  INTERVALS="$gene_intervals" TAG=XG
mark_file_as_intermediate "$TMPDIR"/gene_tagged.bam

invoke_dropseq TagReadWithGeneFunction O="$TMPDIR"/function_tagged.bam ANNOTATIONS_FILE="$refflat" \
  INPUT="$TMPDIR"/gene_tagged.bam


# Stage 5: bead repair

if [ "$bead_repair" -ne 0 ]
then
  mark_file_as_intermediate "$TMPDIR"/function_tagged.bam

  invoke_dropseq DetectBeadSubstitutionErrors INPUT="$TMPDIR"/function_tagged.bam OUTPUT="$TMPDIR"/substitution_repaired.bam \
    TMP_DIR="$TMPDIR" MIN_UMIS_PER_CELL=20 OUTPUT_REPORT="$outdir"/substitution_error_report.txt
  mark_file_as_intermediate "$TMPDIR"/substitution_repaired.bam

  invoke_dropseq DetectBeadSynthesisErrors INPUT="$TMPDIR"/substitution_repaired.bam MIN_UMIS_PER_CELL=20 \
    OUTPUT_STATS="$outdir"/synthesis_error_stats.txt SUMMARY="$outdir"/synthesis_error_summary.txt \
    REPORT="$outdir"/synthesis_error_report.txt CREATE_INDEX=true TMP_DIR="$TMPDIR" OUTPUT="$outdir"/final.bam
else
  $ECHO mv "$TMPDIR"/function_tagged.bam "$outdir"/final.bam
fi


echo 'Completed successfully.'

#!/bin/sh

# MIT License
#
# Copyright 2018 Broad Institute
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.


. "$(dirname "$0")"/defs.sh

progname=$(basename "$0")

outdir=$(pwd)
star_executable=$(which STAR 2> /dev/null)
bgzip_executable=$(which bgzip 2> /dev/null)
samtools_executable=$(which samtools 2> /dev/null)


usage () {
    cat >&2 <<EOF
USAGE: $progname [options]
Create Drop-seq reference metadata bundle.

-n <name>                  : Name for reference metadata set to be created.  Required.
-r <referencefasta>        : Reference fasta of the Drop-seq reference metadata bundle.  Required.
-s <species>               : Species.  Required.
-g <gtf>                   : Gene annotation file.  Required.
-f <filtered-gene-biotype> : Annotations with the given gene biotype will be filtered.  Multiple
                             values may be specified by using this argument more than once, and/or
                             by providing a comma-separated list.  Use ValidateReference command to
                             see the gene biotypes in your GTF in order to decide what to exclude.
                             Default: No gene biotypes are filtered.
-o <outputdir>             : Where to write output bam.  Default: '$outdir'.
-a <STAR_path>             : Full path of STAR.  Default: '$star_executable'.
-b <bgzip_path>            : Full path of bgzip.  Default: '$bgzip_executable'.
-i <samtools_path>         : Full path of samtools.  Default: '$samtools_executable'.
-v                         : Run in verbose mode.
-e                         : Merely echo commands instead of executing.
-h                         : Print usage and exit.
EOF
}


set -e

# Unset all variables to be set based on parameters that have not been
# initialized previously in this script (or a script sourced above) 'in order
# to ensure they're passed on command line rather than inherited from
# somewhere'.
# See https://github.com/broadinstitute/Drop-seq/pull/412#discussion_r1569231368
# for the corresponding discussion.
unset \
  reference_name \
  reference_fasta \
  species \
  gtf \
  filtered_gene_biotypes

while getopts ':n:r:s:g:f:o:a:b:i:veh' options; do
  case $options in
    n ) reference_name=$OPTARG;;
    r ) reference_fasta=$OPTARG;;
    s ) species=$OPTARG;;
    g ) gtf=$OPTARG;;
    f ) filtered_gene_biotypes="${filtered_gene_biotypes+$filtered_gene_biotypes }G=$OPTARG";;
        # support repeating -f: ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
    o ) outdir=$OPTARG;;
    a ) star_executable=$OPTARG;;
    b ) bgzip_executable=$OPTARG;;
    i ) samtools_executable=$OPTARG;;
    v ) verbose=1;;
    e ) ECHO='echo';;
    h ) usage
          exit 0;;
    \? ) usage
         exit 1;;
    * ) usage
          exit 1;;
  esac
done
shift $((OPTIND - 1))

check_TMPDIR

check_set "$reference_name" 'Reference name' '-n'
check_set "$reference_fasta" 'Reference fasta' '-r'
check_set "$species" 'Species' '-s'
check_set "$gtf" 'Gene annotation file' '-g'
check_set "$star_executable" 'STAR path' '-s' 'if STAR is not on PATH'
check_set "$samtools_executable" 'samtools path' '-i' 'if samtools is not on PATH'
check_set "$bgzip_executable" 'bgzip path' '-b' 'if bgzip is not on PATH'


output_fasta=$outdir/$reference_name.fasta
sequence_dictionary=$outdir/$reference_name.dict
output_gtf=$outdir/$reference_name.gtf
reduced_gtf=$outdir/$reference_name.reduced.gtf


invoke_picard NormalizeFasta INPUT="$reference_fasta" OUTPUT="$output_fasta"
if [ -e "$sequence_dictionary" ]
then $ECHO rm "$sequence_dictionary"
fi
invoke_picard CreateSequenceDictionary REFERENCE="$output_fasta" OUTPUT="$sequence_dictionary" SPECIES="$species"
invoke_dropseq FilterGtf GTF="$gtf" SEQUENCE_DICTIONARY="$sequence_dictionary" OUTPUT="$output_gtf $filtered_gene_biotypes"
invoke_dropseq ConvertToRefFlat ANNOTATIONS_FILE="$output_gtf" SEQUENCE_DICTIONARY="$sequence_dictionary" OUTPUT="$outdir/$reference_name".refFlat
invoke_dropseq ReduceGtf GTF="$output_gtf" SEQUENCE_DICTIONARY="$sequence_dictionary" OUTPUT="$reduced_gtf"
invoke_dropseq CreateIntervalsFiles SEQUENCE_DICTIONARY="$sequence_dictionary" REDUCED_GTF="$reduced_gtf" PREFIX="$reference_name" \
           OUTPUT="$outdir"
$ECHO mkdir -p "$outdir"/STAR
check_invoke "$star_executable" --runMode genomeGenerate --genomeDir "$outdir"/STAR --genomeFastaFiles "$output_fasta" \
           --sjdbGTFfile "$output_gtf" --sjdbOverhang 100
check_invoke "$bgzip_executable" "$output_fasta"
check_invoke "$samtools_executable" faidx "$output_fasta".gz


echo 'Reference metadata created sucessfully.'

# MIT License
#
# Copyright 2018 Broad Institute
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

# Shared definitions to be sourced by other scripts

thisdir=$(dirname "$0")

all_classpath=$(echo "$thisdir"/lib/*.jar|tr ' ' ':')

error_exit() {
    echo "ERROR: $*
    " >&2
    exit 1
}

if [ -z "$verbose" ]
then verbose=0
fi

if [ -z "$ECHO" ]
then ECHO=
fi

check_invoke() {
    if [ "$verbose" -eq 1 ]
    then echo "$@"
    fi
    if $ECHO "$@"
    then :
    else error_exit 'non-zero exit status ' $? " executing $*"
    fi
}

# Note: `"$thisdir"` might be a symbolic link to a directory. Appending a final
# `/` ensures the link to be resolved in such a case and is a no-op otherwise.
# Without this (or instructng `find` to follow symbolic links by passing the
# `-L` flag), `find` would fail to detect the Picard `*.jar` file if this
# script is called via a directory symlink.
picard_jar=$(find "$thisdir"/ -name picard\*.jar)

num_picard_jars=$(wc -w << EOF
$picard_jar
EOF
)

if [ "$num_picard_jars" -ne 1 ]
then error_exit 'Could not find one and only one picard.jar in deployment.'
fi

invoke_picard() {
    check_invoke java -classpath "$all_classpath" -Xmx4g -Djava.io.tmpdir="$TMPDIR" picard.cmdline.PicardCommandLine "$@"
}

invoke_dropseq() {
    dropseq_program=$1
    shift
    check_invoke "$thisdir/$dropseq_program" "$@"
}

check_set() {
    value=$1
    name=$2
    flag=$3
    suffix=${4+" $4"}

    if [ -z "$value" ]
    then error_exit "$name has not been specified.  $flag flag is required$suffix."
    fi
}

check_TMPDIR() {
  if [ -z "$TMPDIR" ]
  then error_exit 'TMPDIR environment variable must be set.'
  fi
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/file_util.R
\name{read_table_with_label_for_rownames}
\alias{read_table_with_label_for_rownames}
\title{Read a tab-separated file, drop the first column and use the values of the first column as rownames.}
\usage{
read_table_with_label_for_rownames(file, ...)
}
\arguments{
\item{file}{If suffix is ".gz" it is assumed the file is gzipped.}

\item{...}{passed to data.table::fread()}
}
\description{
Read a tab-separated file, drop the first column and use the values of the first column as rownames.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/string_util.R
\name{strStartsWith}
\alias{strStartsWith}
\title{Test if string starts with given prefix}
\usage{
strStartsWith(theString, thePrefix)
}
\arguments{
\item{theString}{string to be tested}

\item{thePrefix}{prefix to be tested for}
}
\value{
TRUE if theString starts with thePrefix
}
\description{
Test if string starts with given prefix
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/file_util.R
\name{getSparseMatrixDimensions}
\alias{getSparseMatrixDimensions}
\title{read the first fiew lines of a MatrixMarket file to get the header line.}
\usage{
getSparseMatrixDimensions(file)
}
\arguments{
\item{file}{possibly gzipped}
}
\value{
list(numRows, numCols, numPopulatedElements)
}
\description{
read the first fiew lines of a MatrixMarket file to get the header line.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/string_util.R
\name{strEndsWith}
\alias{strEndsWith}
\title{Test if string ends with given suffix}
\usage{
strEndsWith(theString, theExt)
}
\arguments{
\item{theString}{string to be tested}

\item{theExt}{suffix to be tested for}
}
\value{
TRUE if theString ends with theExt
}
\description{
Test if string ends with given suffix
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/file_util.R
\name{read_dge_txt}
\alias{read_dge_txt}
\title{Read a tabular DGE, that may have comment/header lines starting with '@' or '#'}
\usage{
read_dge_txt(path)
}
\arguments{
\item{path}{file to be read.  If has suffix ".gz" it is assumed to be gzipped.}
}
\value{
a data.table with the tabular contents of the file, and header/comment lines attached
        as an attribute named 'Drop-seq.dge.header'
}
\description{
Read a tabular DGE, that may have comment/header lines starting with '@' or '#'
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/string_util.R
\name{maybeRemoveSuffix}
\alias{maybeRemoveSuffix}
\title{Remove a suffix from a string, if it is present.}
\usage{
maybeRemoveSuffix(str, suffix)
}
\arguments{
\item{str}{the string to be truncated}

\item{suffix}{the string to be checked for and removed}
}
\value{
the string with suffix removed, if present, otherwise the original string
}
\description{
If the string does not end with the suffix, it is not truncated.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/estimateDoubletRateFromCellSelectionPrototype.R
\name{estimateDoubletRatePoissonDistribution}
\alias{estimateDoubletRatePoissonDistribution}
\title{Estimate the expected number of doublets from the count of empty/nonempty cell barcodes}
\usage{
estimateDoubletRatePoissonDistribution(
  emptyCount,
  nonEmptyCount,
  showPlot = TRUE
)
}
\arguments{
\item{emptyCount}{The number of cell barcodes that do not encapsulate a cell in the experiment}

\item{nonEmptyCount}{The numbeYr of cell barcodes that encapsulate a cell in the experiment}

\item{showPlot}{Plot the poisson counts distribution using the inferred lambda parameter for the total number of cell barcodes.}
}
\value{
A dataframe contain the input parameters, and the esimated doublet rate and lambda parameter.
}
\description{
Given the count of empty and non-empty cell barcodes, fit data to a poisson distribution
where the empty count matches the number given, and the sum of counts >= 1 equals the non-empty count.
}
\details{
The number of nonEmpty cell barcodes is estimated by any cell selection software you'd like to use - 10x
and other scRNASeq methods will generate this number

The number of empty cell barcodes is slightly harder to estimate - it can be inferred using
cell level metrics of the number of UMIs and %intronic to find cell barcodes that have fewer UMIs and 
(in the case of nuclei) lower pct inronic.  See \code{\link{estimateEmptyCount}}

This estimates a lambda parameter for a Poisson distribution.  Assuming this distribution is reasonable,
it is them possible to estimate the doublet rate as the number of single observations divided by the number of
observations of one or more counts.
}
\examples{
estimateDoubletRatePoissonDistribution(10000,1000)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/file_util.R
\name{countHeaderLines}
\alias{countHeaderLines}
\title{Count the number of lines at the beginning of the file that start with @ or #}
\usage{
countHeaderLines(path)
}
\arguments{
\item{path}{text file to be read, possibly gzipped}
}
\value{
the number of lines at the beginning of the file that start with '@' or '#'
}
\description{
Count the number of lines at the beginning of the file that start with @ or #
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DropSeq.dropulation-package.R
\docType{package}
\name{DropSeq.dropulation-package}
\alias{DropSeq.dropulation}
\alias{DropSeq.dropulation-package}
\title{DropSeq.dropulation: Tools for analyzing Dropulation data}
\description{
Dropulation and Dropulation census functions.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/file_util.R
\name{getDenseDgeDimensions}
\alias{getDenseDgeDimensions}
\title{Read enough of a file to get the number of rows and columns.}
\usage{
getDenseDgeDimensions(file)
}
\arguments{
\item{file}{possibly gzipped}
}
\value{
list(numRows, numCols)
}
\description{
Read enough of a file to get the number of rows and columns.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/string_util.R
\name{splitStringByLength}
\alias{splitStringByLength}
\title{Split string into pieces of the given length}
\usage{
splitStringByLength(s, len)
}
\arguments{
\item{s}{String to be split}

\item{len}{desired length}
}
\value{
vector of pieces.  Note that last piece may not be full length.
}
\description{
Split string into pieces of the given length
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/file_util.R
\name{read_dge_gz}
\alias{read_dge_gz}
\title{Read a tabular DGE, with gene rows and columns that typically are cell barcodes}
\usage{
read_dge_gz(file, decreasing_order_by_size = TRUE)
}
\arguments{
\item{file}{to be read, optionally gzipped}

\item{decreasing_order_by_size}{If true, columns are ordered in decreasing order by colsum}
}
\value{
a data.frame with genes as rownames, no GENE column.
}
\description{
Read a tabular DGE, with gene rows and columns that typically are cell barcodes
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/string_util.R
\name{removeSuffix}
\alias{removeSuffix}
\title{Remove a suffix from a string}
\usage{
removeSuffix(str, suffix)
}
\arguments{
\item{str}{the string to be truncated}

\item{suffix}{the string to be checked for and removed}
}
\value{
the string with suffix removed
}
\description{
It is an error if the string does not end with the suffix.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/file_util.R
\name{write_table_with_label_for_rownames}
\alias{write_table_with_label_for_rownames}
\title{Write a tab-separated file with row and column labels, including a label for the rownames.
Additional args are passed to write.table}
\usage{
write_table_with_label_for_rownames(
  x,
  file,
  rowname_label,
  quote = FALSE,
  sep = "\\t",
  col.names = TRUE,
  ...
)
}
\arguments{
\item{x}{the data frame to be written.}

\item{file}{where to write the data.  If suffix is ".gz", the file is gzipped.}

\item{rowname_label}{the column header for the rownames}

\item{quote}{passed to write.table}

\item{sep}{passed to write.table}

\item{col.names}{passed to write.table}

\item{...}{passed to write.table}
}
\description{
Write a tab-separated file with row and column labels, including a label for the rownames.
Additional args are passed to write.table
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DropulationCensusStandardAnalysis.R
\name{censusSeqQC}
\alias{censusSeqQC}
\title{Run standard analysis for census, roll call, and csi.}
\usage{
censusSeqQC(
  readQualityMetricsFile = NULL,
  censusFile = NULL,
  rollCallFile = NULL,
  csiFile = NULL,
  donorListFile = NULL,
  expName = "",
  outPDF = NULL,
  minNumSNPS = 1000
)
}
\arguments{
\item{readQualityMetricsFile}{A file containing the number of reads that aligned in the experiment. 
This file is generated by Picard's CollectMultipleMetrics. (optional)}

\item{censusFile}{The dropulation census output file}

\item{rollCallFile}{The Roll Call output file}

\item{csiFile}{The CSI output file}

\item{donorListFile}{A list of donors expected in the data set.}

\item{expName}{The name of the experiment.}

\item{outPDF}{A file location where plots will be generated. (optional)}

\item{minNumSNPS}{The minimum number of SNPs to consider a roll call result to be well powered.}
}
\description{
Run standard analysis for census, roll call, and csi.  
All input files are optional, plots will be generated based on the files that are not null.
}
\details{
While many inputs are optional, CensusSeq should be run in combination with RollCall and CSI to
fully evaluate a donor pool.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/file_util.R
\name{fastRead}
\alias{fastRead}
\title{Read a data.table using data.table fread()}
\usage{
fastRead(inFile, comment_regexp = NA, ...)
}
\arguments{
\item{inFile}{path of file to be read}

\item{comment_regexp}{If defined, filter input through "egrep -v comment_regexp"}

\item{...}{passed through to data.table::fread}
}
\value{
a data.table
}
\description{
If inFile ends with .gz, it is gunzipped in a way that is robust to running out of disk space.
Environment variable DROPSEQ_TMPDIR should be set to a directory that has plenty of room and is writable.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/file_util.R
\name{ensure_directory_exists}
\alias{ensure_directory_exists}
\title{Check if a directory exists, and create it if not.  Errors if cannot be created or exists but is not a directory.}
\usage{
ensure_directory_exists(directory, recursive = TRUE)
}
\arguments{
\item{directory}{to be created}

\item{recursive}{if FALSE, the parent directory must exist.}
}
\value{
the directory, always with a trailing slash.  Raises an error if cannot be created
}
\description{
Check if a directory exists, and create it if not.  Errors if cannot be created or exists but is not a directory.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/file_util.R
\docType{data}
\name{MatrixMarketConstants}
\alias{MatrixMarketConstants}
\title{Strings that appear in MatrixMarket files.}
\format{
An object of class \code{list} of length 9.
}
\usage{
MatrixMarketConstants
}
\description{
Strings that appear in MatrixMarket files.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/file_util.R
\name{getDgeDimensions}
\alias{getDgeDimensions}
\title{Determine size of sparse or dense DGE}
\usage{
getDgeDimensions(file)
}
\arguments{
\item{file}{possibly gzipped}
}
\value{
list(numRows, numCols, numPopulatedElements)
}
\description{
Determine size of sparse or dense DGE
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DonorAssignmentStandardAnalysis.R
\name{donorAssignmentQC}
\alias{donorAssignmentQC}
\title{Standard set of analysis for single cell donor assignment.}
\usage{
donorAssignmentQC(
  expName = "",
  likelihoodSummaryFile,
  doubletLikelihoodFile,
  dgeSummaryFile = NULL,
  dgeRawSummaryFile = NULL,
  readsPerCellFile = NULL,
  censusFile = NULL,
  expectedSamplesFile,
  outFileLikelyDonors = NULL,
  outDonorToCellMap = NULL,
  outPDF = NULL,
  outSummaryStatsFile = NULL,
  minimumFractionDonor = 0.002,
  alpha = 0.05,
  rescueDiffuseDoublets = F,
  minNumUMIs = 0,
  dgeFile = NULL,
  outMetaCellFile = NULL,
  selectedCellsForMetaCellFile = NULL,
  outCellBarcodesFile = NULL,
  anonymizeDonors = FALSE
)
}
\arguments{
\item{expName}{The experiment name.  This is used to label plots.}

\item{likelihoodSummaryFile}{The dropulation single donor likelihood file.}

\item{doubletLikelihoodFile}{The dropulation doublet likelihood file.}

\item{dgeSummaryFile}{The DGE summary file.  If cleanup steps have been run on the 
data, the most processed data should be used at this step to preserve that in the metacell summary.  
A DGE summary file is a tab separated file with the follow columns:
* CELL_BARCODE: the cell barcode sequence CELL_BARCODE that identifies a single cell uniquely
* NUM_TRANSCRIPTS: the total number of UMIs captured by a cell.  This is the sum of expression across all genes. 
(optional)}

\item{dgeRawSummaryFile}{The DGE summary file.  This file should contain the number of UMIs original observed in the 
data before any cleanup steps like cellbender. See dgeSummaryFile for file format.  (optional)}

\item{readsPerCellFile}{The reads per cell file. This file is tab delimited, has no header, and has two columns:
1. The number of reads for a cell barcode
2. The cell barcode identity.  
(optional)}

\item{censusFile}{The census results file. (optional)}

\item{expectedSamplesFile}{A file containing the expected list of donors in the experiment. The file has no header,
and a single donor ID on each line.}

\item{outFileLikelyDonors}{Output of which donors are in the experiment based on the Dropulation results.}

\item{outDonorToCellMap}{A map from each cell barcode to the best donor.  This is restricted to cells
that are not doublets and have passed FDR thresholds.  This represents subset of input cells that should
be used in downstream analysis that requires donor labels.}

\item{outPDF}{The output PDF file. (optional)}

\item{outSummaryStatsFile}{The output summary statistics file. (optional)}

\item{minimumFractionDonor}{To determine which donors are in the data, what fraction of cells must contain a donor for the 
donor to be included in the output.  This controls for a low level of miscalls of donor identity.}

\item{alpha}{The p-value threshold for doublets.}

\item{rescueDiffuseDoublets}{[EXPERIMENTAL] Should doublets where the 2nd donor of the pair isn't clear be rescued when possible?  These
cells usually have higher amounts of ambient RNA that makes many potential doublet pairs equally likely.  If set to true,
attempts to differentiate cells assigned to expected donors from noisy cells to recover a subset of barcodes with marginal scores
as singlets.   This method needs a pool where many donors that are evaluated are not expected in the pool (a set of null results).  
Without that null result, this option will erroneously rescue cells as singlets - use with caution!}

\item{minNumUMIs}{Filter cells with fewer than this number of UMIs. (optional)}

\item{dgeFile}{The input DGE file to generate meta cell output. If cleanup steps have been run on the 
data, the most processed data should be used at this step to preserve that in the metacell summary.  This is a tab delimited
flat file with each row containing a gene and each column containing a cell barcode.  The first column name is "GENE", followed by 
cell barcode identifiers.  (optional)}

\item{outMetaCellFile}{Sums the expression across cells of each donor to generate a new expression file for donors instead 
of cells. (optional)}

\item{selectedCellsForMetaCellFile}{Limits meta cell expression to a subset of donors.}

\item{outCellBarcodesFile}{cell barcodes for donors in the experiment (optional)}

\item{anonymizeDonors}{If set to true, donor IDs are changed to DONOR_1, DONOR_2, etc.  Purely for sharing 
visualizations of not-yet-public data.}
}
\description{
This generates a QC report with a number of useful plots, along with optional
outputs that are useful for downstream analysis.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/file_util.R
\name{ensure_trailing_slash}
\alias{ensure_trailing_slash}
\title{Make sure the argument has a trailing slash.}
\usage{
ensure_trailing_slash(directory)
}
\arguments{
\item{directory}{path on which to operate}
}
\value{
the input argument, with a slash appended if it doesn't already end with a slash
}
\description{
Make sure the argument has a trailing slash.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/string_util.R
\name{replaceSuffix}
\alias{replaceSuffix}
\title{Remove a suffix from a file and append a new one.}
\usage{
replaceSuffix(str, oldSuffix, newSuffix)
}
\arguments{
\item{str}{String on which to operate.}

\item{oldSuffix}{suffix to be replaced.}

\item{newSuffix}{the replacement.}
}
\value{
str with oldSuffix replaced by newSuffix
}
\description{
Remove a suffix from a file and append a new one.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/file_util.R
\name{open_conn}
\alias{open_conn}
\title{Creates a file connection with the given open mode.}
\usage{
open_conn(file, open = "")
}
\arguments{
\item{file}{If ends with ".gz", a gzfile() is created; else a regular file() connection.}

\item{open}{mode in which file is opened.  Default: "rb"}
}
\description{
Creates a file connection with the given open mode.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/file_util.R
\name{isMatrixMarket}
\alias{isMatrixMarket}
\title{Determine if a file is in matrix market file format.}
\usage{
isMatrixMarket(file)
}
\arguments{
\item{file}{The file to test}
}
\value{
true if the file is in matrix market format
}
\description{
Determine if a file is in matrix market file format.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/estimateDoubletRateFromCellSelectionPrototype.R
\name{estimateEmptyCount}
\alias{estimateEmptyCount}
\title{Estimate the number of empty cell barcodes in an experiment}
\usage{
estimateEmptyCount(
  cellMetricsFile,
  minPctIntronic = 0.28,
  maxPctIntronic = 0.5,
  minUMIs = 2.8,
  maxUMIs = 3.3
)
}
\arguments{
\item{cellMetricsFile}{A file containing one entry per cell.  The file is tab separated,
and the required columns are:
1. cell_barcode - the string identifying the cell in the experiment.  Usually 12-16 bases long.
2. num_transcripts - the total number of UMIs assigned to each cell.
3. pct_intronic - the fraction of reads or UMIs that are intronic.}

\item{minPctIntronic}{The minimum PCT intronic for the ambient cell barcodes}

\item{maxPctIntronic}{The maximum PCT intronic for the ambient cell barcodes}

\item{minUMIs}{The minimum number of UMIs (in log10) for the ambient cell barcodes}

\item{maxUMIs}{The maximum number of UMIs (in log10) for the ambient cell barcodes}
}
\value{
The number of empty barcodes captured by the bounding box.
}
\description{
Manually draw thresholds around the ambient peak, and count the number of cells
}
